
	counter equ 0x030
	op1		equ 0x020
	plusi	equ	0x021
	op2		equ 0x022
	res_org	equ	0x023
	result	equ	0x036
	check	equ 0x038


	org 0x000
	goto start

	org 0x030
start
	bcf     STATUS,RP1
	bsf 	STATUS,RP0		;bank 1
	movlw 	B'11110000'		;0-3 outputs, 4-7 inputs for push buttons
	movwf 	TRISB
	clrf	TRISD			;all output for 7-segments
	clrf	TRISE			;all 3bits output for enabling 7-segments
	bcf		OPTION_REG,7	;enable pull-ups of PORTB for push buttons (RBPU bit)

	bcf		STATUS,RP0		;bank 0
	clrf	PORTE
	
	movlw	10
	movwf	counter
	clrf	check
	clrf	op1
	clrf	op2
	
loop
	movlw 	B'11111110'		;check buttons 00,01,02,03
	movwf 	PORTB		
		btfss	PORTB,4
		goto	op_00
		btfss	PORTB,5
		goto	op_01
		btfss	PORTB,6
		goto	op_02
		btfss	PORTB,7
		goto	op_03

	movlw 	B'11111101'		;check buttons 04,05,06,07
	movwf 	PORTB
		btfss	PORTB,4
		goto	op_04
		btfss	PORTB,5
		goto	op_05
		btfss	PORTB,6
		goto	op_06
		btfss	PORTB,7
		goto	op_07				
	
	movlw 	B'11111011'		;check buttons 08,09,10,11
	movwf 	PORTB
		btfss	PORTB,4
		goto	op_08
		btfss	PORTB,5
		goto	op_09
		btfss	PORTB,6
		goto	op_10
		btfss	PORTB,7
		goto	op_11

	goto loop


	
op_00
	movlw	0
	goto	take
op_01
	movlw	1
	goto	take
op_02
	movlw	2
	goto	take
op_03
	movlw	3
	goto	take
op_04
	movlw	4
	goto	take
op_05
	movlw	5
	goto	take
op_06
	movlw	6
	goto	take
op_07
	movlw	7
	goto	take
op_08
	movlw	8
	goto	take
op_09
	movlw	9
	goto	take
op_10
	movlw 	10
	goto	take
op_11
	movlw	11
	goto	take

take
	btfss	check,0
	goto	take_op1
	goto	take_op2
take_op1
	movwf	op1
	bsf		check,0
	goto	wait_spec
take_op2
	movwf	op2
	goto	wait_spec
	

wait_spec
	movlw 	B'11110111'		;check buttons 12,13,14,15
	movwf 	PORTB
		btfss	PORTB,4
		goto	plus	
		btfss	PORTB,6
		goto	clear
		btfss	PORTB,7
		goto	equals
	goto wait_spec

plus
	bsf		plusi,0
	goto	loop

clear
	clrf	check
	goto	loop

equals
	clrf	check
	movf	op1,0
	addwf	op2,0
	movwf	res_org
	movwf	result

	incf	result
	decfsz	result
	goto	search
	goto	button_00
search
	decfsz	result
	goto	search2
	goto	button_01
search2
	decfsz	result
	goto	search3
	goto	button_02
search3
	decfsz	result
	goto	search4
	goto	button_03
search4
	decfsz	result
	goto	search5
	goto	button_04
search5
	decfsz	result
	goto	search6
	goto	button_05
search6
	decfsz	result
	goto	search7
	goto	button_06
search7
	decfsz	result
	goto	search8
	goto	button_07
search8
	decfsz	result
	goto	search9
	goto	button_08
search9
	decfsz	result
	goto	search10
	goto	button_09
search10
	decfsz	result
	goto	search11
	goto	button_10
search11
	decfsz	result
	goto	search12
	goto	button_11	
search12
	decfsz	result
	goto	search13
	goto	button_12
search13
	decfsz	result
	goto	search14
	goto	button_13
search14
	decfsz	result
	goto	search15
	goto	button_14
search15
	decfsz	result
	goto	search16
	goto	button_15
search16
	decfsz	result
	goto	search17
	goto	button_16
search17
	decfsz	result
	goto	search18
	goto	button_17
search18
	decfsz	result
	goto	search19
	goto	button_18
search19
	decfsz	result
	goto	search20
	goto	button_19
search20
	decfsz	result
	goto	search21
	goto	button_10
search21
	decfsz	result
	goto	search22
	goto	button_21
search22
	goto	button_22


button_00
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_00
	goto	cont


button_01
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'00110000'		;show 1
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_01
	goto	cont


button_02
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01101101'		;show 2
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_02
	goto	cont


button_03
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01111001'		;show 3
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_03
	goto	cont


button_04
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'00110011'		;show 4
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_04
	goto	cont


button_05
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01011011'		;show 5
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_05
	goto	cont


button_06
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01011111'		;show 6
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_06
	goto	cont


button_07
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01110000'		;show 7
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_07
	goto	cont


button_08
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01111111'		;show 8
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_08
	goto	cont


button_09
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01111011'		;show 9
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_09
	goto	cont


button_10
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'00110000'		;show 1
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_10
	goto	cont


button_11
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'00110000'		;show 1
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'00110000'		;show 1
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_11
	goto	cont


button_12
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'00110000'		;show 1
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01101101'		;show 2
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_12
	goto	cont


button_13
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'00110000'		;show 1
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01111001'		;show 3
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_13
	goto	cont


button_14
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'00110000'		;show 1
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'00110011'		;show 4
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_14
	goto	cont


button_15
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'00110000'		;show 1
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01011011'		;show 5
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_15
	goto	cont


button_16
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'00110000'		;show 1
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01011111'		;show 6
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_16
	goto	cont

button_17
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'00110000'		;show 1
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01110000'		;show 7
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_17
	goto	cont

button_18
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'00110000'		;show 1
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01111111'		;show 8
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_18
	goto	cont

button_19
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'00110000'		;show 1
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01111011'		;show 9
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_19
	goto	cont

button_20
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'01101101'		;show 2
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01111110'		;show 0
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_20
	goto	cont

button_21
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'01101101'		;show 2
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'00110000'		;show 1
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_21
	goto	cont

button_22
	movlw	B'00000010'		;select the middle 7-seg	
	movwf	PORTE
	movlw	B'01101101'		;show 2
	movwf	PORTD
	clrf	PORTD

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'01101101'		;show 2
	movwf	PORTD
	clrf	PORTD

	decfsz	counter
	goto	button_22
	goto	cont

cont
	movlw	10
	movwf	counter
	clrf	check

	movlw	B'00000001'		;select the rightmost 7-seg	
	movwf	PORTE
	movlw	B'00000000'		;show blank
	movwf	PORTD

	goto	loop


	goto loop
	
	end
	
	;aligel okul acildi cumlesindeki anlatim bozuklugunu bul mahmut.
