/*
	ONLY ASM 

*/


header {
	package assembler;
	
	import java.io.*;
	import antlr.*;
	import antlr.collections.AST;
	import antlr.debug.misc.ASTFrame;
	import assembler.GenerateHex;
	import gui.ConsolePane;
	import java.util.ArrayList;
}

class asmLexer extends Lexer;

options {
	k = 2;
	charVocabulary = '\0'..'\377';
	testLiterals = false;
}


tokens
{
	// compiler commands:
		END 	="end";
		EQU 	="equ"; 
		ORG		="org";
		
		
	// ASM instructions:
		ADDWF	="addwf";
		ANDWF	="andwf";
		CLRF	="clrf";
		CLRW	="clrw";
		COMF	="comf";
		DECF	="decf";
		DECFSZ	="decfsz";	
		INCF	="incf";
		INCFSZ	="incfsz";
		IORWF	="iorwf";
		MOVF	="movf";
		MOVWF	="movwf";
		NOP		="nop";
		RLF		="rlf";
		RRF		="rrf";
		SUBWF	="subwf";
		SWAPF	="swapf";
		XORWF	="xorwf";
		BCF		="bcf";
		BSF		="bsf";
		BTFSC	="btfsc";
		BTFSS	="btfss";
		ADDLW	="addlw";
		ANDLW	="andlw";
		CALL	="call";
		CLRWDT	="clrwdt";
		GOTO	="goto";
		IORLW	="iorlw";
		MOVLW	="movlw";
		RETFIE	="retfie";
		RETLW	="retlw";
		RETURN	="return";
		SLEEP	="sleep";
		SUBLW	="sublw";
		XORLW	="xorlw";

}

{	
	public static void main(String[] args)
	{
		ArrayList bpLnum = new ArrayList();
		bpLnum.add(21);	bpLnum.add(22);bpLnum.add(23);bpLnum.add(24);
		//assemble("deneme", "asdasd/www.asm",  null, bpLnum);
	}
	
	public static int assemble(String activeFileName, String activeFilePath, ConsolePane consolePane, ArrayList breakPointLineNumbers, ArrayList bpAddress)
	{
		consolePane.getConsoleEditorPane().setText("Compiling " + activeFilePath + "...\n");
		// Use a try/catch block for parser exceptions
	    String s1="";
	    String s2="";
	    int limit = 0;
	    String s = "";
	    
	    try {

			///////////////////
			//	First Pass
				DataInputStream input = new DataInputStream(new FileInputStream(new File( activeFilePath )));
				
				asmLexer asmlexer = new asmLexer(input); 
				asmParser asmparser = new asmParser(asmlexer); 
				
				asmparser.Initialize(1);

			    asmparser.setBreakPointLineNumbers(breakPointLineNumbers);
			  	
				for(int i=0; i<breakPointLineNumbers.size(); i++)
					System.out.println(breakPointLineNumbers.get(i));
				
				try{
					asmparser.breakPointAddresses=bpAddress;										
					s1=asmparser.program();
				}
	    
			    catch(Exception e) {
			    	consolePane.addText("Error:" + e +"\n");
			    	return 0;
			    }
			
				s = activeFilePath;
				for (int i = 0; i < s.length(); i++) {
						if( s.charAt(i) == '.')
							limit = i;
				}
				if(limit != 0)
					s = s.substring(0, limit);
					
				File tempFile  = new File(s + ".t1");
				FileWriter tempFileWriter = null;

				try {
					tempFileWriter = new FileWriter(tempFile);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					System.out.println("System file could not be created! Exiting program.");
					e.printStackTrace();
				}
				try {
					//initial comments
					//tempFileWriter.write("");
				
				
					tempFileWriter.write(s1); 
					tempFileWriter.close();
				
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

			/////////////////////
			//	Second Pass
				DataInputStream input2 = new DataInputStream(new FileInputStream(new File(s + ".t1")));
				asmLexer asmlexer2 = new asmLexer(input2); 
				asmParser asmparser2 = new asmParser(asmlexer2); 

				asmparser2.Initialize(2);
				asmparser2.setSTable(asmparser.getSTable());
								
				try{
					s2=asmparser2.program();	
				

				}
	    		
	    		
			    catch(Exception e) {
			    	consolePane.addText("Error:" + e +"\n");
			    	return 0;
			    }
			    
			
				
				/*
				System.out.println("OUTPUT OF THE SECOND PASS");			
				System.out.println(s2);
				System.out.println(asmparser2.HEXString);
				System.out.println("asdads");
				*/

				File hexFile  = new File(s + ".t2");
				FileWriter hexFileWriter = null;
				try {
					hexFileWriter = new FileWriter(hexFile);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					System.out.println("System file could not be created! Exiting program.");
					e.printStackTrace();
				}
				try {
					//initial comments
					//tempFileWriter.write(""); 
					hexFileWriter.write(s2); 
					hexFileWriter.close();
				
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

		String filePath = s + ".t2";
		System.out.println("FILEPATH" + filePath);
		GenerateHex generateHex = new GenerateHex(filePath);
		consolePane.addText("Compilation successful.\n");
	    
	    
		return 1;
	    

	    }
	    
	    catch(Exception e) {
	      System.err.println("exception: "+e);
	      
	      e.printStackTrace(System.err);   // so we can get stack trace
	      	return 0;
	    }
	    
	}


		
	
}

	

	COMMENT:
		(	("//" | SEMI) (~('\r'|'\n'))* 
		)	{$setType(Token.SKIP);}
	;

	NEWLINE:
		(	'\r' '\n'
		|	'\r'
		|	'\n'
		) {newline(); }
	;
	
	WS:
		(	' '
		|	'\t'
		|	'\f'
		//|	NEWLINE {newline();}
		) {$setType(Token.SKIP);}
	;
	

	LCURLY:  "{";
	RCURLY:  "}";
	LPAR:	"(";
	RPAR:	")";
	COMMA:	",";
	LBRC:	"[";
	RBRC:	"]";
	SEMI:	";";
	COLON:	":";
	ASSIGN:	"=";
	PLUS:	"+";
	MINUS:	"-";
	AND:	"&&";
	OR:		"||";
	EQ:		"==";
	NEQ:	"!=";	
	LT:		"<";	
	GT:		">";	
	LTE:	"<=";	
	GTE:	">=";	
	
	protected DIGIT:
		(	'0'..'9'
		)
	;
	
	protected DECIMAL:
		(DIGIT)+ 
	;
	
	protected BINARY:
		(("b"|"B") "'" ('0'| '1')+ "'") 
	;
	
	protected HEX:
		("0x" (DIGIT | 'A'..'F')+)
	;
	
	protected IDENT:
	{//System.out.println("IDENT");
	
	}
	(
		(LETTER)(LETTER | DIGIT)*)
	;
	
	NUMBER  options { testLiterals=true;}: 
		  BINARY	  
		| HEX
		| DECIMAL
 	  	| IDENT {$setType(IDENT);}
	;
	
	ADDRESS:{/*System.out.println("ADDRESS");*/
	
	}
	(
		("*"(DECIMAL | HEX)))
	;
	
		
	LITERAL:
		NUMBER | ("'" ('\0'..'\377') "'") 
	;
	
	protected LETTER:
		('a'..'z') | ('A'..'Z') | "_"
	;

{
import java.util.ArrayList;
}
class asmParser extends Parser;

options { 
	k = 2;
	buildAST = true;
	defaultErrorHandler=  false;
	
}
tokens {
	PROGRAM;
	SUBPROGRAMBODY;
	BASICDECL;
	CONSTDECL;
	STATEMENT;
	ORGSTATEMENT;
	INSTRUCTIONSTATEMENT;
	ASMSTATEMENT;
	ADDWFSTATEMENT;
	ANDWFSTATEMENT;
	CLRFSTATEMENT;
	CLRWSTATEMENT;
	COMFSTATEMENT;
	DECFSTATEMENT;
	DECFSZSTATEMENT;
	INCFSTATEMENT;
	INCFSZSTATEMENT;
	IORWFSTATEMENT;
	MOVFSTATEMENT;
	MOVWFSTATEMENT;
	NOPSTATEMENT;
	RLFSTATEMENT;
	RRFSTATEMENT;
	SUBWFSTATEMENT;
	SWAPFSTATEMENT;
	XORWFSTATEMENT;
	BSFSTATEMENT;
	BCFSTATEMENT;
	BTFSCSTATEMENT;
	BTFSSSTATEMENT;
	ADDLWSTATEMENT;
	ANDLWSTATEMENT;
	CALLSTATEMENT;
	CLRWDTSTATEMENT;
	GOTOSTATEMENT;
	IORLWSTATEMENT;
	MOVLWSTATEMENT;
	RETFIESTATEMENT;
	RETLWSTATEMENT;
	SLEEPSTATEMENT;
	SUBLWSTATEMENT;
	XORLWSTATEMENT;
	RETURNSTATEMENT;
	LABELSTATEMENT;
	
}
{
	ArrayList breakPointLineNumbers = null;
	ArrayList breakPointAddresses = new ArrayList();
	
	int passNumber=1;
	int addressNumber=0;
	String HEXString = "";
	int hexword=0;
	SymbolTable sTable = new SymbolTable();
	private int lineNumber = 1; 
	public int getCurrentLine() { return lineNumber;}
	 
	public void setBreakPointLineNumbers(ArrayList bPointLineNo)
	{
		breakPointLineNumbers = bPointLineNo;
	}
	
	/* convert the current line number
		into instruction memory address
	*/
	public void convertBreakPoint(int lineNumber)
	{
		if(breakPointLineNumbers==null)
			return;
		else
		{
			int size = breakPointLineNumbers.size();
			for (int i = 0; i < size ; i++) 
			{
				if(lineNumber == (Integer) breakPointLineNumbers.get(i))
				{
					System.out.println("pass " + passNumber + ": break point on line " + lineNumber + 
						 " is converted to address " + addressNumber);
					breakPointAddresses.add(addressNumber);
				}
				
			}
		}			
	}
	
	public void showBreakPointLineNumbers()
	{
		int size = breakPointLineNumbers.size();
		System.out.println("Break Point Line Numbers on pass" + passNumber + ":");
		for (int i = 0; i < size ; i++) 
		{
			System.out.println(breakPointLineNumbers.get(i));
		}
	}
	
	public void showBreakPointAddresses()
	{
		int size = breakPointAddresses.size();
		System.out.println("Break Point Addresses:");
		for (int i = 0; i < size ; i++) 
		{
			System.out.println(breakPointAddresses.get(i));
		}
	
	}
	
	
	public SymbolTable getSTable() {
		return sTable;
	}
	
	public void setSTable(SymbolTable sT) {
		sTable = sT;
		sTable.printTable();
	}
	
	public void Initialize(int pNum)
	{
		addressNumber=0;
		HEXString = "";
		hexword=0;
		passNumber = pNum;
	}
	
	public int str2int(String str)
	{
			String tempval="";
			int data=0;

			if((str.length() > 1)&& (str.charAt(1)=='x'))
			{	
				//hex
				tempval = str.substring(2);
				data = Integer.parseInt(tempval, 16);
			}else if((str.charAt(0)=='b') | (str.charAt(0)=='B'))
			{ //binary
				tempval = str.substring(2, str.length()-1);
				/*System.out.println("BINARY:"+tempval);*/
				data = Integer.parseInt(tempval, 2);
				
			}else
			{
				if((str.charAt(0)=='d') | (str.charAt(0)=='D'))
				{ //D'10'
					tempval = str.substring(2, str.length()-1);
					data = Integer.parseInt(tempval, 10);
				
				}else //standard decimal
					data = Integer.parseInt(str);
			}
			
			return data;
	}
	public class Symbol {
		private String name;
		private int value;
		
		Symbol (String nm, int val) {
			name = nm;
			value = val;
		}
			
		public void printSymbol() {
			/*System.out.println("|\t"+name+"\t\t"+value+"\t|");
			System.out.println("+--------------------------------+");*/
		}
	}
	
	public class SymbolTable {
		private ArrayList sTable;
		
		SymbolTable () {
			sTable = new ArrayList();
			
			// Kucuk harf versiyonlari da eklenecek:
			//BANK0
			add("TMR0", "1");
			add("PCL", "2");
			add("STATUS", "3");
				add("RP1", "6");
				add("RP0", "5");
			add("FSR", "4");
			add("PORTA", "5");
			add("PORTB", "6");
			add("PORTC", "7");
			add("PORTD", "8");
			add("PORTE", "9");
			add("PCLATH", "10");
			add("INTCON", "11");
			add("PIR1", "12");
			add("PIR2", "13");
			add("TMR1L", "14");
			add("TMR1H", "15");
			add("T1CON", "16");
			add("TMR2", "17");
			add("T2CON", "18");
			add("SSPBUF", "19");
			add("SSPCON", "20");
			add("CCPR1L", "21");
			add("CCPR1H", "22");
			add("CCP1CON", "23");
			add("RCSTA", "24");
			add("TXREG", "25");
			add("RCREG", "26");
			add("CCPR2L", "27");
			add("CCPR2H", "28");
			add("CCP2CON", "29");
			add("ADRESH", "30");
			add("ADCON0", "31");
			
			//BANK1
			add("OPTION_REG", "1");
			add("TRISA", "5");
			add("TRISB", "6");
			add("TRISC", "7");
			add("TRISD", "8");
			add("TRISE", "9");
			add("PCLATH", "10");
			add("INTCON", "11");
			add("PIE1", "12");
			add("PIE2", "13");
			add("PCON", "14");
			add("SSPCON2", "17");
			add("PR2", "18");
			add("SSPADD", "19");
			add("SSPSTAT", "20");
			add("TXSTA", "24");
			add("SPBRG", "25");
			add("ADRESL", "30");
			add("ADCON1", "31");

			//BANK2
			add("EEDATA", "12");
			add("EEADR", "13");
			add("EEDATH", "14");
			add("EEADRH", "15");

			//BANK3
			add("EECON1", "12");
			add("EECON2", "13");
		}
	  
		
		public void add(String name, String value) {
			String tempval="";
			int data=0;

			data = str2int(value);
			
			Symbol sym = new Symbol(name, data);
			sTable.add(sym);
		}
		
		public int getSize() {
			return sTable.size();
		}
		
		public Symbol getSymbol(int i) {
			return (Symbol)sTable.get(i);
		}

		public int getSymbolValue(String s_name) {
			int size = sTable.size();
			Symbol entry = null;
			for (int i = 0; i < size; i++) {
				entry = (Symbol)sTable.get(i);
				if(s_name.compareTo(entry.name) == 0) {
				  return entry.value;
				}
			}
			//Print an error here, there is no such variable 
			return -1;
			
		} 
	
		public boolean isDefined (String s_name) {
			int size = sTable.size();
			for (int i = 0; i < size; i++) {
				Symbol entry = (Symbol)sTable.get(i);
				if((s_name.compareTo(entry.name) == 0)) 
				{
				   	return true;
				}
			}
			return false;
		}
				

		public void printTable() {
			/*System.out.println("+------- SYMBOL TABLE  ----------+");
			System.out.println("|\tNAME"+"\t\t"+"VALUE\t|");
			System.out.println("+--------------------------------+");
			*/
			for (int i = 0; i < sTable.size(); i++) {
				getSymbol(i).printSymbol();
			}
		}
	}
}
/*
	firstPass returns [String s=""]:
	{
		String s1="";
	}
		(	(NEWLINE!)*
			(basicDecl {} (NEWLINE!)+)*
			(
				 (s1=labelStatement {s += s1 + " ";} (NEWLINE!{s += "\n";})*)
				|(s1=otherStatement {s += s1 + " ";} (NEWLINE!{s += "\n";})*)
			)*
		)
	;
	
	otherStatement returns [String str=""]:
	{
	}
		(		a:LITERAL 	{str += a.getText();}
			|	b:ADDRESS	{str += b.getText();}
			|	c:NUMBER	{str += c.getText();}
			|	d:IDENT		{str += d.getText();}
			|	e:LCURLY	{str += e.getText();}
			|	f:RCURLY	{str += f.getText();}
			|	g:LPAR		{str += g.getText();}
			|	h:RPAR		{str += h.getText();}
			|	i:COMMA		{str += i.getText();}
			|	j:LBRC		{str += j.getText();}
			|	k:RBRC		{str += k.getText();}
			|	l:SEMI		{str += l.getText();}
			//|	m:COLON		{str += m.getText();}
			|	n:ASSIGN	{str += n.getText();}
			|	o:PLUS		{str += o.getText();}
			|	p:MINUS		{str += p.getText();}
			|	q:AND		{str += q.getText();}
			|	r:OR		{str += r.getText();}
			|	s:EQ		{str += s.getText();}
			|	t:NEQ		{str += t.getText();}
			|	u:LT		{str += u.getText();}
			|	v:GT		{str += v.getText();}
			|	w:LTE		{str += w.getText();}
			|	x:GTE		{str += x.getText();}
			|	y:WS		{str += y.getText();}
			|	z:END		{str += z.getText();}
			|	aa:ORG		{str += aa.getText();}
			|	ab:ADDWF	{str += ab.getText();}
			|	ac:ANDWF	{str += ac.getText();}
			|	ad:CLRF		{str += ad.getText();}
			|	ae:CLRW		{str += ae.getText();}
			|	af:COMF		{str += af.getText();}
			|	ag:DECF		{str += ag.getText();}
			|	ah:DECFSZ	{str += ah.getText();}
			|	ai:INCF		{str += ai.getText();}
			|	aj:INCFSZ	{str += aj.getText();}
			|	ak:IORWF	{str += ak.getText();}
			|	al:MOVF		{str += al.getText();}
			|	am:MOVWF	{str += am.getText();}
			|	an:NOP		{str += an.getText();}
			|	ao:RLF		{str += ao.getText();}
			|	ap:RRF		{str += ap.getText();}
			|	aq:SUBWF	{str += aq.getText();}
			|	ar:SWAPF	{str += ar.getText();}
			|	as:XORWF	{str += as.getText();}
			|	at:BCF		{str += at.getText();}
			|	au:BSF		{str += au.getText();}
			|	av:BTFSC	{str += av.getText();}
			|	aw:BTFSS	{str += aw.getText();}
			|	ax:ADDLW	{str += ax.getText();}
			|	ay:ANDLW	{str += ay.getText();}
			|	az:CALL		{str += az.getText();}
			|	ba:CLRWDT	{str += ba.getText();}
			|	bb:GOTO		{str += bb.getText();}
			|	bc:IORLW	{str += bc.getText();}
			|	bd:MOVLW	{str += bd.getText();}
			|	be:RETFIE	{str += be.getText();}
			|	bf:RETLW	{str += bf.getText();}
			|	bg:RETURN	{str += bg.getText();}
			|	bh:SLEEP	{str += bh.getText();}
			|	bi:SUBLW	{str += bi.getText();}
			|	bj:XORLW	{str += bj.getText();}
			|	bk:COMMENT	{str += bk.getText();}
		)
		{
			System.out.println("STR=" + str );
		}
	;
*/
	
	program returns [String s=""]: {String s1=""; /*System.out.println("program");*/ }
		((NEWLINE!{lineNumber++;})*
		 s1=subprogramBody 	
		)
		{
			s+=s1;
			/*System.out.println("end program");
			System.out.println("pass " + passNumber + " completed.");	
			//s+= "endprg\n";
			*/
		}	
	;
  
  
	subprogramBody returns [String s=""]:
	{
		String s2="";
	}
		(( basicDecl {addressNumber++;/*System.out.println(addressNumber);*/} (NEWLINE!{lineNumber++;})+)*
			( s2=statement 	{	convertBreakPoint(getCurrentLine());
								addressNumber++;s+=s2;/*System.out.println(addressNumber);*/

							} (NEWLINE!{{lineNumber++;}s+="\n";})+)*
				(END)?
		)
		{
			//System.out.println("matched subp");
			//#subprogramBody = #([SUBPROGRAMBODY,"subprogramBody"], #subprogramBody);
		}	
	;

	
	basicDecl: //{System.out.println("basicDecl");}
		(
			constDecl
		)
		{
			
		}
	;
	
	constDecl: //{System.out.println("constDecl");}
		(id:IDENT EQU! num:NUMBER 
		)
		{
			sTable.add(id.getText(), num.getText());
			sTable.printTable();
			addressNumber--;
		}
		
	;
	
	
	statement returns [String s=""]:		 
		(  s=instructionStatement 
		 | s=orgStatement
		 | s=labelStatement
		)
		{
		}
		;
	
	orgStatement returns [String s=""]:
		{
			String pass1="";
			String addr="";
		}
		( ORG!{pass1+="org ";} (num:NUMBER {addr=num.getText();pass1+=num.getText();} | id:IDENT{addr=""+sTable.getSymbolValue(id.getText());pass1+=id.getText();})
		)
		{
			addressNumber = str2int(addr);
						
			/*System.out.println("orgStatement " + addressNumber);*/
			// Modify the addressNumber with the contents of the NUMBER or IDENT=constant 
				
			
				
			s += "\n";
			s += Integer.toString(addressNumber, 16);
			s += ":\n";		
			
			addressNumber--; // ORG Statement does not occupy address in the memory, so reduce the address by 1
			
			if(passNumber==1)
				s = pass1;
		}
	;
	
	instructionStatement returns [String s=""]:
		( 
		  s=asmStatement
		)
		{
		}
	; 
	

	asmStatement returns [String s=""]:
		(
		   s=addwfStatement
		 | s=andwfStatement
		 | s=clrfStatement
		 | s=clrwStatement
		 | s=comfStatement
		 | s=decfStatement
		 | s=decfszStatement
		 | s=incfStatement
		 | s=incfszStatement
		 | s=iorwfStatement
		 | s=movfStatement
		 | s=movwfStatement
		 | s=nopStatement
		 | s=rlfStatement
		 | s=rrfStatement
		 | s=subwfStatement
		 | s=swapfStatement
		 | s=xorwfStatement
		 | s=bcfStatement
		 | s=bsfStatement
		 | s=btfscStatement
		 | s=btfssStatement
		 | s=addlwStatement
		 | s=andlwStatement
		 | s=callStatement
		 | s=clrwdtStatement
		 | s=gotoStatement
		 | s=iorlwStatement
		 | s=movlwStatement
		 | s=retfieStatement
		 | s=retlwStatement
		 | s=returnStatement
		 | s=sleepStatement
		 | s=sublwStatement
		 | s=xorlwStatement	
		)
		{
			
		} 
	;
	
	addwfStatement returns [String s=""]:
		{
			int arg1=0;
			int arg2=1;
			String pass1="";
		}
		( ADDWF!{pass1+="addwf ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();}) 
				 (COMMA!{pass1+=",";} (id2:IDENT {arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();} | num2:NUMBER {arg2 = str2int(num2.getText());pass1+=num2.getText();}))?
		)
		{
			
			if((arg1>0x3F) || (arg2 > 1))
				System.out.println("ERROR!!!!!");
				
				
			hexword = 0x0700;
			hexword += arg2 * 0x0080; 
			hexword += arg1; 
	
			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
							
			/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
			
			if(passNumber==1)
				s = pass1;
		}
	;

	andwfStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
			int arg2=1;
		}
		( ANDWF!{pass1+="andwf ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();}) 
				 (COMMA!{pass1+=",";} (id2:IDENT {arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();} | num2:NUMBER {arg2 = str2int(num2.getText());pass1+=num2.getText();}))?
		)
		{
			if((arg1>0x3F) || (arg2 > 1))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x0500;
			hexword += arg2 * 0x0080; 
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;

	clrfStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
		}
		( CLRF!{pass1+="clrf ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();}) 
		)
		{
			if((arg1>0x3F))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x0180;
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	clrwStatement returns [String s=""]:
		{
			String pass1="";	
		}
		( CLRW!{pass1+="clrw ";} )
		{
			hexword = 0x0100;
			
			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	comfStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
			int arg2=1;
		}
		( COMF!{pass1+="comf ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();}) 
				 (COMMA!{pass1+=",";} (id2:IDENT {arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();} | num2:NUMBER {arg2 = str2int(num2.getText());pass1+=num2.getText();}))?
		)
		{
			if((arg1>0x3F) || (arg2 > 1))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x0900;
			hexword += arg2 * 0x0080; 
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
/*			System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	decfStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
			int arg2=1;
		}
		( DECF!{pass1+="decf ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();}) 
				 (COMMA!{pass1+=",";} (id2:IDENT {arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();} | num2:NUMBER {arg2 = str2int(num2.getText());pass1+=num2.getText();}))?
		)
		{
			if((arg1>0x7F) || (arg2 > 1))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x0300;
			hexword += arg2 * 0x0080; 
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	decfszStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
			int arg2=1;
		}
		( DECFSZ!{pass1+="decfsz ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();}) 
				 (COMMA!{pass1+=",";} (id2:IDENT {arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();} | num2:NUMBER {arg2 = str2int(num2.getText());pass1+=num2.getText();}))?
		)
		{
			if((arg1>0x7F) || (arg2 > 1))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x0B00;
			hexword += arg2 * 0x0080; 
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	incfStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
			int arg2=1;
		}
		( INCF!{pass1+="incf ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();}) 
				 (COMMA!{pass1+=",";} (id2:IDENT {arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();} | num2:NUMBER {arg2 = str2int(num2.getText());pass1+=num2.getText();}))?
		)
		{
			if((arg1>0x7F) || (arg2 > 1))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x0A00;
			hexword += arg2 * 0x0080; 
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	incfszStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
			int arg2=1;
		}
		( INCFSZ!{pass1+="incfsz ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();}) 
				 (COMMA!{pass1+=",";} (id2:IDENT {arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();} | num2:NUMBER {arg2 = str2int(num2.getText());pass1+=num2.getText();}))?
		)
		{
			if((arg1>0x7F) || (arg2 > 1))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x0F00;
			hexword += arg2 * 0x0080; 
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	iorwfStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
			int arg2=1;
		}
		( IORWF!{pass1+="iorwf ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();}) 
				 (COMMA!{pass1+=",";} (id2:IDENT {arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();} | num2:NUMBER {arg2 = str2int(num2.getText());pass1+=num2.getText();}))?
		)
		{
			if((arg1>0x7F) || (arg2 > 1))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x0400;
			hexword += arg2 * 0x0080; 
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	movfStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
			int arg2=1;
		}
		( MOVF!{pass1+="movf ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();}) 
				 (COMMA!{pass1+=",";} (id2:IDENT {arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();} | num2:NUMBER {arg2 = str2int(num2.getText());pass1+=num2.getText();}))?
		)
		{
			if((arg1>0x7F) || (arg2 > 1))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x0800;
			hexword += arg2 * 0x0080; 
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	movwfStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
		}
		( MOVWF!{pass1+="movwf ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();}) 
		)
		{
			if((arg1>0x7F))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x0080;
			hexword += arg1; 
			//System.out.println("HEX " + arg1 + " " + hexword);
			
			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			//System.out.println("HEX " + arg1 + " " + HEXString);
			if(passNumber==1)
				s = pass1;
		}
	;
	
	nopStatement returns [String s=""]:
		{
			String pass1="";
		}
		( NOP!{pass1+="nop ";}
		)
		{
			hexword = 0x0000;

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	rlfStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
			int arg2=1;
		}
		(
			RLF!{pass1+="rlf ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();}) 
				 (COMMA!{pass1+=",";} (id2:IDENT {arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();} | num2:NUMBER {arg2 = str2int(num2.getText());pass1+=num2.getText();}))?
		)
		{
			if((arg1>0x7F) || (arg2 > 1))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x0D00;
			hexword += arg2 * 0x0080; 
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	rrfStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
			int arg2=1;
		}
		( RRF!{pass1+="rrf ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();}) 
				 (COMMA!{pass1+=",";} (id2:IDENT {arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();} | num2:NUMBER {arg2 = str2int(num2.getText());pass1+=num2.getText();}))?
		)
		{
			if((arg1>0x7F) || (arg2 > 1))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x0C00;
			hexword += arg2 * 0x0080; 
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	subwfStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
			int arg2=1;
		}
		( SUBWF!{pass1+="subwf ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();}) 
				 (COMMA!{pass1+=",";} (id2:IDENT {arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();} | num2:NUMBER {arg2 = str2int(num2.getText());pass1+=num2.getText();}))?
		)
		{
			if((arg1>0x7F) || (arg2 > 1))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x0200;
			hexword += arg2 * 0x0080; 
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	swapfStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
			int arg2=1;
		}
		( SWAPF!{pass1+="swapf ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();}) 
				 (COMMA!{pass1+=",";} (id2:IDENT {arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();} | num2:NUMBER {arg2 = str2int(num2.getText());pass1+=num2.getText();}))?
		)
		{
			if((arg1>0x7F) || (arg2 > 1))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x0E00;
			hexword += arg2 * 0x0080; 
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	xorwfStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
			int arg2=1;
		}
		( XORWF!{pass1+="xorwf ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();}) 
				 (COMMA!{pass1+=",";} (id2:IDENT {arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();} | num2:NUMBER {arg2 = str2int(num2.getText());pass1+=num2.getText();}))?
		)
		{
			if((arg1>0x7F) || (arg2 > 1))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x0600;
			hexword += arg2 * 0x0080; 
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	bcfStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
			int arg2=0;
		}
		( BCF!{pass1+="bcf ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();}) 
				 (COMMA!{pass1+=",";} (id2:IDENT {arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();} | num2:NUMBER {arg2 = str2int(num2.getText());pass1+=num2.getText();}))?
		)
		{
			if((arg1>0x7F) || (arg2 > 7))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x1000;
			hexword += arg2 * 0x0080; 
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	bsfStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
			int arg2=0;
		}
		( BSF!{pass1+="bsf ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();}) 
				 (COMMA!{pass1+=",";} (id2:IDENT {arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();} | num2:NUMBER {arg2 = str2int(num2.getText());pass1+=num2.getText();}))?
		)
		{
			if((arg1>0x7F) || (arg2 > 7))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x1400;
			hexword += arg2 * 0x0080; 
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	btfscStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
			int arg2=0;
		}
		( BTFSC!{pass1+="btfsc ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();}) 
				 (COMMA!{pass1+=",";} (id2:IDENT {arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();} | num2:NUMBER {arg2 = str2int(num2.getText());pass1+=num2.getText();}))?
		)
		{
			if((arg1>0x7F) || (arg2 > 7))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x1800;
			hexword += arg2 * 0x0080; 
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	btfssStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
			int arg2=0;
		}
		( BTFSS!{pass1+="btfss ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();}) 
				 (COMMA!{pass1+=",";} (id2:IDENT {arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();} | num2:NUMBER {arg2 = str2int(num2.getText());pass1+=num2.getText();}))?
		)
		{
			if((arg1>0x7F) || (arg2 > 7))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x1C00;
			hexword += arg2 * 0x0080; 
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	addlwStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
		}
		( ADDLW!{pass1+="addlw ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();})
		)
		{
			if((arg1>0xFF))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x3F00;
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	andlwStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
		}
		( ANDLW!{pass1+="andlw ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();})
		)
		{
			if((arg1>0xFF))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x3900;
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	callStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
		}
		( CALL!{pass1+="call ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();})
		)
		{
			if((arg1>0x3FF))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x2000;
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	clrwdtStatement returns [String s=""]:
		{
			String pass1="";	
		}
	
		( CLRWDT!{pass1+="clrwdt ";} 
		)
		{
			
			hexword = 0x0064;

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	gotoStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
		}
		( GOTO!{pass1+="goto ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();})
		)
		{
			if((arg1>0x3FF))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x2800;
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	iorlwStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
		}
		( IORLW!{pass1+="goto ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();})
		)
		{
			if((arg1>0xFF))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x3800;
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	movlwStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
		}
		( MOVLW!{pass1+="movlw ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();})
		)
		{
			
			if((arg1>0xFF))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x3000;
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	retfieStatement returns [String s=""]:
		{
		String pass1="";
		}
		( RETFIE! {pass1+="retfie ";}
		)
		{
			
			hexword = 0x0009;
			
			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	retlwStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
		}
		( RETLW!{pass1+="retlw ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();})
		)
		{
			if((arg1>0xFF))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x3400;
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	returnStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
		}
		( RETURN!{pass1+="return ";} 
		)
		{
			if((arg1>0xFF))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x0008;
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	sleepStatement returns [String s=""]:
		{
			String pass1="";
		}
		( SLEEP!{pass1+="sleep ";}
		)
		{
			
			hexword = 0x0063;

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	sublwStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
		}
		( SUBLW!{pass1+="sublw ";} (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();})
		)
		{
			if((arg1>0xFF))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x3C00;
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	
	xorlwStatement returns [String s=""]:
		{
			String pass1="";
			int arg1=0;
		}
		( XORLW!{pass1+="xorlw ";}  (id1:IDENT {arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();} | num1:NUMBER {arg1 = str2int(num1.getText());pass1+=num1.getText();})
		)
		{
			if((arg1>0xFF))
				System.out.println("ERROR!!!!!");
			
			hexword = 0x3A00;
			hexword += arg1; 

			HEXString += Integer.toString(hexword, 16) + " " ;
			s += Integer.toString(hexword, 16) + " " ;
			
			/*System.out.println("HEX " + arg1 + " " + HEXString);*/
			if(passNumber==1)
				s = pass1;
		}
	;
	


	labelStatement returns [String s=""]:
		// label with colon
		( (id:IDENT COLON! 		
			)
			{
				// insert the label and the addressNumber to the labelTable
				if(passNumber==1)
					sTable.add(id.getText(), Integer.toString(addressNumber));
				sTable.printTable();
				
				
				/*System.out.println("labelStatement");*/
				if(passNumber==1)
					s += id.getText() + ":\n";
				else
					s += Integer.toString(addressNumber, 16) + ":\n";
				
				addressNumber--;
			}
		// label without colon
		)| (id2:IDENT) 
			{
				// insert the label and the addressNumber to the labelTable
				if(passNumber==1)
					sTable.add(id2.getText(), Integer.toString(addressNumber));
				sTable.printTable();
				
				
				/*System.out.println("labelStatement");*/
				if(passNumber==1)
					s += id2.getText() + ":\n";
				else
					s += Integer.toString(addressNumber, 16) + ":\n";
				
				addressNumber--;
			}
	;

	
	