package gui;

import java.awt.Dimension;

import javax.swing.JEditorPane;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;

/**
 * This class represents the console component of the GUI.
 * Console panel is used for outputting messages and errors.
 *
 */
@SuppressWarnings("serial")
public class ConsolePane extends JTabbedPane {

	private JScrollPane ConsoleScrollPane = null;
	private JEditorPane ConsoleEditorPane = null;

	public ConsolePane() {
		// TODO Auto-generated constructor stub
		this.initialize();
	}
		

	public ConsolePane(int tabPlacement) {
		super(tabPlacement);
		this.initialize();
		// TODO Auto-generated constructor stub
	}

	public ConsolePane(int tabPlacement, int tabLayoutPolicy) {
		super(tabPlacement, tabLayoutPolicy);
		this.initialize();
		// TODO Auto-generated constructor stub
	}

	/**
	 * This method initializes the console panel
	 * 
	 */
	private void initialize() {
        this.setSize(new Dimension(621, 78));
        this.setName("Console");
        this.addTab("Console", null, this.getConsoleScrollPane(), null);
	}


	/**
	 * This method initializes ConsoleScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getConsoleScrollPane() {
		if (this.ConsoleScrollPane == null) {
			this.ConsoleScrollPane = new JScrollPane();
			this.ConsoleScrollPane.setViewportView(this.getConsoleEditorPane());
			
			
		}
		return this.ConsoleScrollPane;
	}

	/**
	 * This method initializes ConsoleEditorPane	
	 * 	
	 * @return javax.swing.JEditorPane	
	 */
	public JEditorPane getConsoleEditorPane() {
		if (this.ConsoleEditorPane == null) {
			this.ConsoleEditorPane = new JEditorPane();
			
		}
		return this.ConsoleEditorPane;
	}
	
	/**
	 * This method appends the given text to the console text
	 * @param text
	 */
	public void addText(String text) {
		String s = this.getConsoleEditorPane().getText();
		s += text;
		this.getConsoleEditorPane().setText(s);
	}

}  //  @jve:decl-index=0:visual-constraint="19,53"
