package gui;

import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.File;

import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.tree.DefaultMutableTreeNode;
/**
 * This class creates a new file dialog. After dialog is disposed,
 * the file is added into the editor panel and workspace is updated.
 */
@SuppressWarnings("serial")
public class NewFileFrame extends JFrame {

	public PFrame mainFrame = null;
	public GuiController guiController= null;
	public EditorPane editorPane = null;
	private JPanel mainPanel = null;
	private JPanel radioButtonPanel = null;
	private JRadioButton ASMRadioButton = null;
	private JRadioButton ASMppRadioButton = null;
	private JRadioButton TestRadioButton = null;
	private JPanel fileNamePanel = null;
	private JLabel fileNameLabel = null;
	private JTextField fileNameTextField = null;
	private JPanel bottomRightPanel = null;
	private JButton finishButton = null;
	private JButton cancelButton = null;
	private ButtonGroup createFileButtonGroup = null;  //  @jve:decl-index=0:
	private String extension = "asm";
	
	public NewFileFrame(PFrame pframe, EditorPane ePane){
		super();
		this.mainFrame = pframe;
		this.mainFrame.setEnabled(false);
		this.guiController = new GuiController();
		this.editorPane = ePane;
		initialize();
		
		
	}

	/**
	 * This method initializes the class fields
	 * 
	 */
	private void initialize() {
        this.setSize(new Dimension(296, 199));
        this.setContentPane(getMainPanel());
        this.setTitle("New File");
        this.addWindowListener(new WindowListener(){

			public void windowActivated(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}

			public void windowClosed(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}

			public void windowClosing(WindowEvent e) {
				// TODO Auto-generated method stub
				dispose();
				mainFrame.setEnabled(true);
			}

			public void windowDeactivated(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}

			public void windowDeiconified(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}

			public void windowIconified(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}

			public void windowOpened(WindowEvent e) {
				// TODO Auto-generated method stub
				
			}});
        getCreateFileButtonGroup();
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getMainPanel() {
		if (mainPanel == null) {
			mainPanel = new JPanel();
			mainPanel.setLayout(null);
			mainPanel.add(getRadioButtonPanel(), null);
			mainPanel.add(getFileNamePanel(), null);
			mainPanel.add(getBottomRightPanel(), null);
		}
		return mainPanel;
	}
	
	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getRadioButtonPanel() {
		if (radioButtonPanel == null) {
			radioButtonPanel = new JPanel();
			radioButtonPanel.setLayout(new BoxLayout(getRadioButtonPanel(), BoxLayout.Y_AXIS));
			radioButtonPanel.setBounds(new Rectangle(7, 8, 179, 82));
			radioButtonPanel.add(getASMRadioButton(), null);
			radioButtonPanel.add(getASMppRadioButton(), null);
			radioButtonPanel.add(getTestRadioButton(), null);
		}
		return radioButtonPanel;
	}

	/**
	 * This method initializes jRadioButton	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getASMRadioButton() {
		if (ASMRadioButton == null) {
			ASMRadioButton = new JRadioButton();
			ASMRadioButton.setText("ASM File");
			ASMRadioButton.setSelected(true);
			ASMRadioButton.addItemListener(new ItemListener(){

				public void itemStateChanged(ItemEvent e) {
					// TODO Auto-generated method stub
					setExtension("asm");
				}});
		}
		return ASMRadioButton;
	}

	/**
	 * This method initializes jRadioButton1	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getASMppRadioButton() {
		if (ASMppRadioButton == null) {
			ASMppRadioButton = new JRadioButton();
			ASMppRadioButton.setText("ASM++ File");
			ASMppRadioButton.addItemListener(new ItemListener(){

				public void itemStateChanged(ItemEvent e) {
					// TODO Auto-generated method stub
					setExtension("asmpp");
				}});
		}
		return ASMppRadioButton;
	}

	/**
	 * This method initializes jRadioButton2	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getTestRadioButton() {
		if (TestRadioButton == null) {
			TestRadioButton = new JRadioButton();
			TestRadioButton.setText("Test File");
			TestRadioButton.addItemListener(new ItemListener(){

				public void itemStateChanged(ItemEvent e) {
					// TODO Auto-generated method stub
					setExtension("test");
				}});
		}
		return TestRadioButton;
	}

	/**
	 * This method initializes jPanel2	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getFileNamePanel() {
		if (fileNamePanel == null) {
			fileNamePanel = new JPanel();
			fileNamePanel.setLayout(new BoxLayout(getFileNamePanel(), BoxLayout.X_AXIS));
			fileNamePanel.setBounds(new Rectangle(8, 93, 276, 25));
			fileNameLabel = new JLabel();
			fileNameLabel.setText("File Name: ");
			fileNamePanel.add(fileNameLabel, null);
			fileNamePanel.add(getFileNameTextField(), null);
		}
		return fileNamePanel;
	}

	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getFileNameTextField() {
		if (fileNameTextField == null) {
			fileNameTextField = new JTextField();
			fileNameTextField.addKeyListener(new KeyListener(){

				public void keyPressed(KeyEvent e) {
					// TODO Auto-generated method stub
					
				}

				public void keyReleased(KeyEvent e) {
					// TODO Auto-generated method stub
					if(fileNameTextField.getText().length() > 0)
						getFinishButton().setEnabled(true);
					else getFinishButton().setEnabled(false);
					
				}

				public void keyTyped(KeyEvent e) {
					// TODO Auto-generated method stub
					
				}});
		}
		return fileNameTextField;
	}

	/**
	 * This method initializes bottomRightPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getBottomRightPanel() {
		if (bottomRightPanel == null) {
			bottomRightPanel = new JPanel();
			bottomRightPanel.setLayout(new BoxLayout(getBottomRightPanel(), BoxLayout.X_AXIS));
			bottomRightPanel.setBounds(new Rectangle(126, 127, 157, 32));
			bottomRightPanel.add(getFinishButton(), null);
			bottomRightPanel.add(getCancelButton(), null);
		}
		return bottomRightPanel;
	}

	/**
	 * This method initializes finishButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getFinishButton() {
		if (finishButton == null) {
			finishButton = new JButton();
			finishButton.setText("Finish");
			finishButton.setEnabled(false);
			finishButton.addActionListener(new ActionListener(){

				public void actionPerformed(ActionEvent e) {
					// TODO Auto-generated method stub
					
					if(mainFrame.systemFile.existsActiveProject)
					{
						String fileName = getFileNameTextField().getText()+"."+getExtension();
						String filePath = mainFrame.activeProject.getProjectPath();
						if(filePath.charAt(filePath.length()-1) == File.separatorChar)
							filePath = filePath.substring(0, filePath.length()-1);
						filePath += File.separatorChar+fileName;
						
						//filePath = filePath.substring(2, filePath.length());
						mainFrame.activeProject.projectFile.fileList.add(filePath);
						mainFrame.activeProject.projectFile.save();
						//System.out.println("active"+filePath);
						guiController.newFileMenuItemPressed(mainFrame, editorPane, fileName, filePath);
						
						mainFrame.workspacePane.projectRoot.removeAllChildren();
						
						DefaultMutableTreeNode activeworkspaceNode = new DefaultMutableTreeNode(mainFrame.activeProject.getProjectName());
						String inactiveProjectPath = null;
						int start = 0;
						int end =0;
						
						for (int i = 0; i < mainFrame.activeProjectFile.fileList.size(); i++) {
							inactiveProjectPath = mainFrame.activeProjectFile.fileList.get(i);
							
							start = inactiveProjectPath.lastIndexOf(File.separatorChar)+1;
							end = inactiveProjectPath.length();
							inactiveProjectPath = inactiveProjectPath.substring(start,end);
							
							activeworkspaceNode.add(new DefaultMutableTreeNode(inactiveProjectPath));
						}
						
						mainFrame.workspacePane.projectRoot.add(activeworkspaceNode);
						
						for(int i = 0; i < mainFrame.systemFile.activeWorkspaces.size();i++)
						{
							inactiveProjectPath = (String)mainFrame.systemFile.activeWorkspaces.get(i);
							
							start = inactiveProjectPath.lastIndexOf(File.separatorChar)+1;
							end = inactiveProjectPath.length();
							inactiveProjectPath = inactiveProjectPath.substring(start,end);
							
							mainFrame.workspacePane.projectRoot.add(new DefaultMutableTreeNode(inactiveProjectPath));
							
						}
						
						mainFrame.workspacePane.model.nodeStructureChanged((DefaultMutableTreeNode) mainFrame.workspacePane.model.getRoot());
					}
					else
					{
						JOptionPane.showMessageDialog(null, "There are no active projects.",
									"Error:File could not be created", JOptionPane.ERROR_MESSAGE);
					}
					
		
					dispose();
					mainFrame.setEnabled(true);
					mainFrame.setVisible(true);
				}});
		}
		return finishButton;
	}

	/**
	 * This method initializes cancelButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getCancelButton() {
		if (cancelButton == null) {
			cancelButton = new JButton();
			cancelButton.setText("Cancel");
			cancelButton.addActionListener(new ActionListener(){

				public void actionPerformed(ActionEvent e) {
					// TODO Auto-generated method stub
					dispose();
					mainFrame.setEnabled(true);
					mainFrame.setVisible(true);
				}});
		}
		return cancelButton;
	}
	
	public ButtonGroup getCreateFileButtonGroup() {
		if (createFileButtonGroup == null) {
			createFileButtonGroup = new ButtonGroup();
			createFileButtonGroup.add(getASMRadioButton());
			createFileButtonGroup.add(getASMppRadioButton());
			createFileButtonGroup.add(getTestRadioButton());
		}
		return createFileButtonGroup;
	}

	public String getExtension() {
		return extension;
	}

	public void setExtension(String extension) {
		this.extension = extension;
	}

}  //  @jve:decl-index=0:visual-constraint="65,46"
