package picmicrocontroller;
/**
 * 
 * This class provides operations related with the PC 
 * register of PIC 16F877
 *
 */
public class ProgramCounter {
	
	PIC pic = null;
	/**
	 * Main constructor of program counter class.
	 *
	 */
	public ProgramCounter(PIC tpic)
	{
		this.pic = tpic;
	}
	
	/**
	 * This method returns 
	 * @return
	 */
	public int getPC() {
		int pchval = this.pic.dataMemory.getPCH();
		
		int pclval = this.pic.dataMemory.read(2);
		
		if(pchval < 0 )
			pchval += 256;
		if(pclval < 0 )
			pclval += 256;
		return pclval + pchval * 256;
		
	}
	
	public void setPC(int newVal) {
		byte pchval = (byte)(newVal / 256);
		byte pclval = (byte)(newVal % 256);
		
		this.pic.dataMemory.setPCH(pchval);	  //pch
		this.pic.dataMemory.write(10, pchval); //pclath
		this.pic.dataMemory.write(2, pclval);  //pcl
		//System.out.println("pch = " + pchval + " pcl=" + pclval);
	}
	
	public void increment() {
		this.setPC((this.getPC() +1));
	}
	
	public void incrementBy2() {
		
	}
}
