/**
 * 
 */
package projectManager;

/**
 * Project class manages creation, saving, loading the projects and 
 * recording any changes about them.
 * @author maho
 *
 */
public class Project {
	
	private String projectName;
	private String projectPath;
	private String projectDescription;
	private boolean isActive;
	public ProjectFile projectFile;
	
	/**
	 * @param projectName
	 * @param projectPath
	 */
	public Project(String projectName, String projectPath) {
		this.projectName = projectName;
		this.projectPath = projectPath;
		projectFile = new ProjectFile(this);
	}
	/**
	 * @param projectFile
	 */
	public Project(ProjectFile projectFile) {
		this.projectFile = projectFile;
		projectName = projectFile.fileName;
		projectPath = projectFile.filePath;
		projectDescription  = projectFile.projectDescription;//!!more than description
		isActive = true;
	}
	/**
	 * @return the isActive
	 */
	public boolean isActive() {
		return isActive;
	}
	/**
	 * @param isActive the isActive to set
	 */
	public void setActive(boolean isActive) {
		this.isActive = isActive;
	}
	/**
	 * @return the projectDescription
	 */
	public String getProjectDescription() {
		return projectDescription;
	}
	/**
	 * @param projectDescription the projectDescription to set
	 */
	public void setProjectDescription(String projectDescription) {
		this.projectDescription = projectDescription;
	}
	/**
	 * @return the projectName
	 */
	public String getProjectName() {
		return projectName;
	}
	/**
	 * @param projectName the projectName to set
	 */
	public void setProjectName(String projectName) {
		this.projectName = projectName;
	}
	/**
	 * @return the projectPath
	 */
	public String getProjectPath() {
		return projectPath;
	}
	/**
	 * @param projectPath the projectPath to set
	 */
	public void setProjectPath(String projectPath) {
		this.projectPath = projectPath;
	}

}
