/**
 * 
 */
package simulator;

import java.awt.HeadlessException;
import java.awt.Rectangle;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.WindowConstants;

import picmicrocontroller.PIC;

/**
 * This class is the panel where memory content of a PIC 16F877.
 * @author maho
 *
 */
@SuppressWarnings("serial")
public class MemoryFrame extends JFrame {
	
	String[] columnNames = {"Address",
			"Value",
			"Address",
			"Value",
			"Address",
			"Value",
			"Address",
			"Value",};
	
	
	private JTable jTable = null;
	private JTable jTable1 = null;
	
	
	public Object[][] data2;
	public Object[][] data;

	protected PIC pic;

	private JPanel jPanel = null;
	private JScrollPane jScrollPane = null;


	private JScrollPane jScrollPane1 = null;


	private SimulatorFrame simulatorFrame;
	
	/**
	 * Main constructor for the memory frame.
	 * @param title
	 * @throws HeadlessException
	 */
	public MemoryFrame(SimulatorFrame simulatorFrame,PIC pic) {
		// TODO Auto-generated constructor stub
		super();
		this.pic = pic;
		this.simulatorFrame = simulatorFrame;
		initialize();
	}
	
	public void initialize()
	{
		        this.setResizable(false);
		        this.setBounds(new Rectangle(544, 0, 735, 508));
				this.setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);
		        
		        data2 = new Object[96][8];

		        Object[][] dataTemp = {
				{"001h TMR0", this.pic.getDataMemory().output(0, 1),
					"081h OPTION_REG", this.pic.getDataMemory().output(1, 1),
					"101h TMR0", this.pic.getDataMemory().output(2, 1),
					"181h OPTION_REG", this.pic.getDataMemory().output(3, 1),
				},
				{"002h PCL", this.pic.getDataMemory().output(0, 2),
					"082h PCL", this.pic.getDataMemory().output(1, 2),
					"102h PCL", this.pic.getDataMemory().output(2, 2),
					"182h PCL", this.pic.getDataMemory().output(3, 2),
				},
				{"003h STATUS", this.pic.getDataMemory().output(0, 3),
					"083h STATUS", this.pic.getDataMemory().output(1, 3),
					"103h STATUS", this.pic.getDataMemory().output(2, 3),
					"183h STATUS", this.pic.getDataMemory().output(3, 3),
				},
				{"004h FSR", this.pic.getDataMemory().output(0, 4),
					"084h FSR", this.pic.getDataMemory().output(1, 4),
					"104h FSR", this.pic.getDataMemory().output(2, 4),
					"184h FSR", this.pic.getDataMemory().output(3, 4),
				},
				{"005h PORTA", this.pic.getDataMemory().output(0, 5),
					"085h TRISA", this.pic.getDataMemory().output(1, 5),
					"105h", "UNIMPLEMENTED",
					"185h", "UNIMPLEMENTED",
				},
				{"006h PORTB", this.pic.getDataMemory().output(0, 6),
					"086h TRISB", this.pic.getDataMemory().output(1, 6),
					"106h PORTB", this.pic.getDataMemory().output(2, 6),
					"186h TRISB", this.pic.getDataMemory().output(3, 6),
				},
				{"007h PORTC", this.pic.getDataMemory().output(0, 7),
					"087h TRISC", this.pic.getDataMemory().output(1, 7),
					"107h", "UNIMPLEMENTED",
					"187h", "UNIMPLEMENTED",
				},
				{"008h PORTD", this.pic.getDataMemory().output(0, 8),
					"088h TRISD", this.pic.getDataMemory().output(1, 8),
					"108h", "UNIMPLEMENTED",
					"188h", "UNIMPLEMENTED",
				},
				{"009h PORTE", this.pic.getDataMemory().output(0, 9),
					"089h TRISE", this.pic.getDataMemory().output(1, 9),
					"109h", "UNIMPLEMENTED",
					"189h", "UNIMPLEMENTED",
				},
				{"00Ah PCLATH", this.pic.getDataMemory().output(0, 10),
					"08Ah PCLATH", this.pic.getDataMemory().output(1, 10),
					"10Ah PCLATH", this.pic.getDataMemory().output(2, 10),
					"18Ah PCLATH", this.pic.getDataMemory().output(3, 10),
				},
				{"00Bh INTCON", this.pic.getDataMemory().output(0, 11),
					"08Bh INTCON", this.pic.getDataMemory().output(1, 11),
					"10Bh INTCON", this.pic.getDataMemory().output(2, 11),
					"18Bh INTCON", this.pic.getDataMemory().output(3, 11),
				},
				{"00Ch PIR1", this.pic.getDataMemory().output(0, 12),
					"08Ch PIE1", this.pic.getDataMemory().output(1, 12),
					"10Ch EEDATA", this.pic.getDataMemory().output(2, 12),
					"18Ch EECON1", this.pic.getDataMemory().output(3, 12),
				},
				{"00Dh PIR2", this.pic.getDataMemory().output(0, 13),
					"08Dh PIE2", this.pic.getDataMemory().output(1, 13),
					"10Dh EEADR", this.pic.getDataMemory().output(2, 13),
					"18Dh EECON2", this.pic.getDataMemory().output(3, 13),
				},
				{"00Eh TMR1L", this.pic.getDataMemory().output(0, 14),
					"08Eh PCON", this.pic.getDataMemory().output(1, 14),
					"10Eh EEDATH", this.pic.getDataMemory().output(2, 14),
					"18Eh", "RESERVED",
				},
				{"00Fh TMR1H", this.pic.getDataMemory().output(0, 15),
					"08Fh", "UNIMPLEMENTED",
					"10Fh EEADRH", this.pic.getDataMemory().output(2, 15),
					"18Fh", "RESERVED",
				},
				{"010h T1CON", this.pic.getDataMemory().output(0, 16),
					"090h", "UNIMPLEMENTED",
					"110h", this.pic.getDataMemory().output(2, 16),
					"190h", this.pic.getDataMemory().output(3, 16),
				},
				{"011h TMR2", this.pic.getDataMemory().output(0, 17),
					"091h SSPCON2", this.pic.getDataMemory().output(1, 17),
					"111h", this.pic.getDataMemory().output(2, 17),
					"191h", this.pic.getDataMemory().output(3, 17),
				},
				{"012h T2CON", this.pic.getDataMemory().output(0, 18),
					"092h PR2", this.pic.getDataMemory().output(1, 18),
					"112h", this.pic.getDataMemory().output(2, 18),
					"192h", this.pic.getDataMemory().output(3, 18),
				},
				{"013h SSPBUF", this.pic.getDataMemory().output(0, 19),
					"093h SSPADD", this.pic.getDataMemory().output(1, 19),
					"113h", this.pic.getDataMemory().output(2, 19),
					"193h", this.pic.getDataMemory().output(3, 19),
				},
				{"014h SSPCON", this.pic.getDataMemory().output(0, 20),
					"094h SSPSTAT", this.pic.getDataMemory().output(1, 20),
					"114h", this.pic.getDataMemory().output(2, 20),
					"194h", this.pic.getDataMemory().output(3, 20),
				},
				{"015h CCPR1L", this.pic.getDataMemory().output(0, 21),
					"095h", "UNIMPLEMENTED",
					"115h", this.pic.getDataMemory().output(2, 21),
					"195h", this.pic.getDataMemory().output(3, 21),
				},
				{"016h CCPR1H", this.pic.getDataMemory().output(0, 22),
					"096h", "UNIMPLEMENTED",
					"116h", this.pic.getDataMemory().output(2, 22),
					"196h", this.pic.getDataMemory().output(3, 22),
				},
				{"017h CCP1CON", this.pic.getDataMemory().output(0, 23),
					"097h SSPCON2", "UNIMPLEMENTED",
					"117h", this.pic.getDataMemory().output(2, 23),
					"197h", this.pic.getDataMemory().output(3, 23),
				},
				{"018h RCSTA", this.pic.getDataMemory().output(0, 24),
					"098h TXSTA", this.pic.getDataMemory().output(1, 24),
					"118h", this.pic.getDataMemory().output(2, 24),
					"198h", this.pic.getDataMemory().output(3, 24),
				},
				{"019h TXREG", this.pic.getDataMemory().output(0, 25),
					"099h SPBRG", this.pic.getDataMemory().output(1, 25),
					"119h", this.pic.getDataMemory().output(2, 25),
					"199h", this.pic.getDataMemory().output(3, 25),
				},
				{"01Ah RCREG", this.pic.getDataMemory().output(0, 26),
					"09Ah", "UNIMPLEMENTED",
					"11Ah", this.pic.getDataMemory().output(2, 26),
					"19Ah", this.pic.getDataMemory().output(3, 26),
				},
				{"01Bh CCPR2L", this.pic.getDataMemory().output(0, 27),
					"09Bh SSPCON2", "UNIMPLEMENTED",
					"11Bh", this.pic.getDataMemory().output(2, 27),
					"19Bh", this.pic.getDataMemory().output(3, 27),
				},
				{"01Ch CCPR2H", this.pic.getDataMemory().output(0, 28),
					"09Ch CMCON", this.pic.getDataMemory().output(1, 28),
					"11Ch", this.pic.getDataMemory().output(2, 28),
					"19Ch", this.pic.getDataMemory().output(3, 28),
				},
				{"01Dh CCP2CON", this.pic.getDataMemory().output(0, 29),
					"09Dh CVRCON", this.pic.getDataMemory().output(1, 29),
					"11Dh", this.pic.getDataMemory().output(2, 29),
					"19Dh", this.pic.getDataMemory().output(3, 29),
				},
				{"01Eh ADRESH", this.pic.getDataMemory().output(0, 30),
					"09Eh ADRESL", this.pic.getDataMemory().output(1, 30),
					"11Eh", this.pic.getDataMemory().output(2, 30),
					"19Eh", this.pic.getDataMemory().output(3, 30),
				},
				{"011h ADCON0", this.pic.getDataMemory().output(0, 31),
					"091h ADCON1", this.pic.getDataMemory().output(1, 31),
					"111h", this.pic.getDataMemory().output(2, 31),
					"191h", this.pic.getDataMemory().output(3, 31),
				}
		};
		
		data = dataTemp;
		
		for(int i=0;i<4;i++)
		{
			for(int j=32;j<128;j++)
			{
				this.data2[j-32][2*i]=new Object();
				this.data2[j-32][2*i+1]= new Object();
				this.data2[j-32][2*i]=((j+ i*128)<=255?"0":"")+Integer.toHexString(j+ i*128)+"h";
				this.data2[j-32][2*i+1]=this.pic.getDataMemory().output(i, j);
			}
		}
		
		
		this.setContentPane(getJPanel());
		this.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				
				MemoryFrame.this.simulatorFrame.getMemoryFrameToggle().setSelected(false);
			
			}});
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new JPanel();
			jPanel.setLayout(null);
			jPanel.add(getJScrollPane(), null);
			jPanel.add(getJScrollPane1(), null);
		}
		return jPanel;
	}

	/**
	 * This method initializes and returns the scroll pane	
	 * 	which contains first half of memory tables.
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane() {
		if (this.jScrollPane == null) {
			this.jScrollPane = new JScrollPane();
			this.jScrollPane.setBounds(new Rectangle(9, 13, 711, 238));
			this.jScrollPane.setViewportView(this.getJTable());
		}
		return this.jScrollPane;
	}
	/**
	 * This method initializes and returns the first table.	
	 * 	
	 * @return javax.swing.JTable	
	 */
	public JTable getJTable() {
		if (this.jTable == null) {
			this.jTable = new JTable(this.data, this.columnNames);
		}
		return this.jTable;
	}
	/**
	 * This method initializes and returns the scroll pane1
	 * which contains second half of memory tables.	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane1() {
		if (this.jScrollPane1 == null) {
			this.jScrollPane1 = new JScrollPane();
			this.jScrollPane1.setBounds(new Rectangle(9, 253, 711, 217));
			this.jScrollPane1.setViewportView(this.getJTable1());
		}
		return this.jScrollPane1;
	}
	/**
	 * This method initializes and returns the second table.	
	 * 	
	 * @return javax.swing.JTable	
	 */
	public JTable getJTable1() {
		if (this.jTable1 == null) {
			this.jTable1 = new JTable(this.data2,this.columnNames);
		}
		return this.jTable1;
	}
	public void updateField(Object data, int rowadds, int coladds)
	{
		this.jTable1.getModel().setValueAt(data, rowadds, coladds);

	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
