package simulator;

import java.awt.*;
/**
 * This class is the visualisation of the seven segment array peripheral of
 * CENG336 board
 *
 */
@SuppressWarnings("serial")
public class SevenSegmentPanel extends javax.swing.JPanel {
    
	boolean[][] state;
    /**
     * Main constructor for the seven segment array panel.
     */
    public SevenSegmentPanel() {
        this.initComponents();
    }
    
    public void initComponents() {
    	this.state = new boolean[3][8];
    	for(int i=0; i<3; i++)
    		for(int j=0; j<8; j++)
    			this.state[i][j] = false;
    	
    }

    @Override
	public void paintComponents(Graphics g) {
    	
    
    	
    	int thick = 6;		//thickness of each segment
    	int length = 45;	//length of each segment
    	
    	//the offset values from the left upper corner of the frame
        int base_x;	
        int base_y;
        
        //the space between two 7segment displays
        int space_between = 100;
        
        //the colors used in seven segment displays
        Color line_color = Color.LIGHT_GRAY;
        Color fill_color = Color.RED;
        
        //fill_color = fill_color.darker();
        
        
        //left most 7 segment
        
        base_x = 105;
        base_y = 60;
        
        g.setColor(line_color);
        
        g.drawLine(base_x+thick, base_y, base_x+thick+length, base_y);
        g.drawLine(base_x+thick, base_y, base_x+thick, base_y+thick);
        g.drawLine(base_x+thick, base_y+thick, base_x+thick+length, base_y+thick);
        g.drawLine(base_x+thick+length, base_y, base_x+thick+length, base_y+thick);
        
        g.drawLine(base_x, base_y+thick, base_x, base_y+thick+length);
        g.drawLine(base_x+thick, base_y+thick, base_x+thick, base_y+thick+length);
        g.drawLine(base_x, base_y+thick, base_x+thick, base_y+thick);
        g.drawLine(base_x, base_y+thick+length, base_x+thick, base_y+thick+length);
        
        g.drawLine(base_x+thick+length, base_y+thick, base_x+thick+length, base_y+thick+length);
        g.drawLine(base_x+thick+length+thick, base_y+thick, base_x+thick+length+thick, base_y+thick+length);
        g.drawLine(base_x+thick+length, base_y+thick, base_x+thick+length+thick, base_y+thick);
        g.drawLine(base_x+thick+length, base_y+thick+length, base_x+thick+length+thick, base_y+thick+length);
        
        g.drawLine(base_x+thick, base_y+thick+length, base_x+thick+length, base_y+thick+length);
        g.drawLine(base_x+thick, base_y+thick+length, base_x+thick, base_y+thick+length+thick);
        g.drawLine(base_x+thick, base_y+thick+length+thick, base_x+thick+length, base_y+thick+length+thick);
        g.drawLine(base_x+thick+length, base_y+thick+length, base_x+thick+length, base_y+thick+length+thick);
        
        g.drawLine(base_x, base_y+thick+length+thick, base_x, base_y+thick+length+thick+length);
        g.drawLine(base_x+thick, base_y+thick+length+thick, base_x+thick, base_y+thick+length+thick+length);
        g.drawLine(base_x, base_y+thick+length+thick, base_x+thick, base_y+thick+length+thick);
        g.drawLine(base_x, base_y+thick+length+thick+length, base_x+thick, base_y+thick+length+thick+length);
        
        g.drawLine(base_x+thick+length, base_y+thick+length+thick, base_x+thick+length, base_y+thick+length+thick+length);
        g.drawLine(base_x+thick+length+thick, base_y+thick+length+thick, base_x+thick+length+thick, base_y+thick+length+thick+length);
        g.drawLine(base_x+thick+length, base_y+thick+length+thick, base_x+thick+length+thick, base_y+thick+length+thick);
        g.drawLine(base_x+thick+length, base_y+thick+length+thick+length, base_x+thick+length+thick, base_y+thick+length+thick+length);
        
        g.drawLine(base_x+thick, base_y+thick+length+thick+length, base_x+thick+length, base_y+thick+length+thick+length);
        g.drawLine(base_x+thick, base_y+thick+length+thick+length, base_x+thick, base_y+thick+length+thick+length+thick);
        g.drawLine(base_x+thick, base_y+thick+length+thick+length+thick, base_x+thick+length, base_y+thick+length+thick+length+thick);
        g.drawLine(base_x+thick+length, base_y+thick+length+thick+length, base_x+thick+length, base_y+thick+length+thick+length+thick);
        
        g.drawLine(base_x+thick+length+thick+thick, base_y+thick+length+thick+length, base_x+thick+length+thick+thick+thick, base_y+thick+length+thick+length);
        g.drawLine(base_x+thick+length+thick+thick, base_y+thick+length+thick+length, base_x+thick+length+thick+thick, base_y+thick+length+thick+length+thick);
        g.drawLine(base_x+thick+length+thick+thick, base_y+thick+length+thick+length+thick, base_x+thick+length+thick+thick+thick, base_y+thick+length+thick+length+thick);
        g.drawLine(base_x+thick+length+thick+thick+thick, base_y+thick+length+thick+length, base_x+thick+length+thick+thick+thick, base_y+thick+length+thick+length+thick);
      
        g.setColor(fill_color);
        
        if(this.state[0][7])
        	g.fillRect(base_x+thick+length+thick+thick, base_y+thick+length+thick+length, thick, thick);	
        if(this.state[0][6])	//a
        	g.fillRect(base_x+thick, base_y, length, thick);
        if(this.state[0][5])	//b
        	g.fillRect(base_x+thick+length, base_y+thick, thick, length);
        if(this.state[0][4])	//c
        	g.fillRect(base_x+thick+length, base_y+thick+length+thick, thick, length);
        if(this.state[0][3])	//d
        	g.fillRect(base_x+thick, base_y+thick+length+thick+length, length, thick);
        if(this.state[0][2])	//e
        	g.fillRect(base_x, base_y+thick+length+thick, thick, length);
        if(this.state[0][1])	//f
        	g.fillRect(base_x, base_y+thick, thick, length);
        if(this.state[0][0])	//g
        	g.fillRect(base_x+thick, base_y+thick+length, length, thick);
        
        
//middle 7 segment
        
        base_x = base_x + space_between;
        //base_y = 45;
        
        g.setColor(line_color);
        
        g.drawLine(base_x+thick, base_y, base_x+thick+length, base_y);
        g.drawLine(base_x+thick, base_y, base_x+thick, base_y+thick);
        g.drawLine(base_x+thick, base_y+thick, base_x+thick+length, base_y+thick);
        g.drawLine(base_x+thick+length, base_y, base_x+thick+length, base_y+thick);
        
        g.drawLine(base_x, base_y+thick, base_x, base_y+thick+length);
        g.drawLine(base_x+thick, base_y+thick, base_x+thick, base_y+thick+length);
        g.drawLine(base_x, base_y+thick, base_x+thick, base_y+thick);
        g.drawLine(base_x, base_y+thick+length, base_x+thick, base_y+thick+length);
        
        g.drawLine(base_x+thick+length, base_y+thick, base_x+thick+length, base_y+thick+length);
        g.drawLine(base_x+thick+length+thick, base_y+thick, base_x+thick+length+thick, base_y+thick+length);
        g.drawLine(base_x+thick+length, base_y+thick, base_x+thick+length+thick, base_y+thick);
        g.drawLine(base_x+thick+length, base_y+thick+length, base_x+thick+length+thick, base_y+thick+length);
        
        g.drawLine(base_x+thick, base_y+thick+length, base_x+thick+length, base_y+thick+length);
        g.drawLine(base_x+thick, base_y+thick+length, base_x+thick, base_y+thick+length+thick);
        g.drawLine(base_x+thick, base_y+thick+length+thick, base_x+thick+length, base_y+thick+length+thick);
        g.drawLine(base_x+thick+length, base_y+thick+length, base_x+thick+length, base_y+thick+length+thick);
        
        g.drawLine(base_x, base_y+thick+length+thick, base_x, base_y+thick+length+thick+length);
        g.drawLine(base_x+thick, base_y+thick+length+thick, base_x+thick, base_y+thick+length+thick+length);
        g.drawLine(base_x, base_y+thick+length+thick, base_x+thick, base_y+thick+length+thick);
        g.drawLine(base_x, base_y+thick+length+thick+length, base_x+thick, base_y+thick+length+thick+length);
        
        g.drawLine(base_x+thick+length, base_y+thick+length+thick, base_x+thick+length, base_y+thick+length+thick+length);
        g.drawLine(base_x+thick+length+thick, base_y+thick+length+thick, base_x+thick+length+thick, base_y+thick+length+thick+length);
        g.drawLine(base_x+thick+length, base_y+thick+length+thick, base_x+thick+length+thick, base_y+thick+length+thick);
        g.drawLine(base_x+thick+length, base_y+thick+length+thick+length, base_x+thick+length+thick, base_y+thick+length+thick+length);
        
        g.drawLine(base_x+thick, base_y+thick+length+thick+length, base_x+thick+length, base_y+thick+length+thick+length);
        g.drawLine(base_x+thick, base_y+thick+length+thick+length, base_x+thick, base_y+thick+length+thick+length+thick);
        g.drawLine(base_x+thick, base_y+thick+length+thick+length+thick, base_x+thick+length, base_y+thick+length+thick+length+thick);
        g.drawLine(base_x+thick+length, base_y+thick+length+thick+length, base_x+thick+length, base_y+thick+length+thick+length+thick);
        
        g.drawLine(base_x+thick+length+thick+thick, base_y+thick+length+thick+length, base_x+thick+length+thick+thick+thick, base_y+thick+length+thick+length);
        g.drawLine(base_x+thick+length+thick+thick, base_y+thick+length+thick+length, base_x+thick+length+thick+thick, base_y+thick+length+thick+length+thick);
        g.drawLine(base_x+thick+length+thick+thick, base_y+thick+length+thick+length+thick, base_x+thick+length+thick+thick+thick, base_y+thick+length+thick+length+thick);
        g.drawLine(base_x+thick+length+thick+thick+thick, base_y+thick+length+thick+length, base_x+thick+length+thick+thick+thick, base_y+thick+length+thick+length+thick);
      
        g.setColor(fill_color);
        
        if(this.state[1][7])
        	g.fillRect(base_x+thick+length+thick+thick, base_y+thick+length+thick+length, thick, thick);	
        if(this.state[1][6])	//a
        	g.fillRect(base_x+thick, base_y, length, thick);
        if(this.state[1][5])	//b
        	g.fillRect(base_x+thick+length, base_y+thick, thick, length);
        if(this.state[1][4])	//c
        	g.fillRect(base_x+thick+length, base_y+thick+length+thick, thick, length);
        if(this.state[1][3])	//d
        	g.fillRect(base_x+thick, base_y+thick+length+thick+length, length, thick);
        if(this.state[1][2])	//e
        	g.fillRect(base_x, base_y+thick+length+thick, thick, length);
        if(this.state[1][1])	//f
        	g.fillRect(base_x, base_y+thick, thick, length);
        if(this.state[1][0])	//g
        	g.fillRect(base_x+thick, base_y+thick+length, length, thick);
        
        
//right most 7 segment
        
        base_x = base_x + space_between;
        //base_y = 45;
        
        g.setColor(line_color);
        
        g.drawLine(base_x+thick, base_y, base_x+thick+length, base_y);
        g.drawLine(base_x+thick, base_y, base_x+thick, base_y+thick);
        g.drawLine(base_x+thick, base_y+thick, base_x+thick+length, base_y+thick);
        g.drawLine(base_x+thick+length, base_y, base_x+thick+length, base_y+thick);
        
        g.drawLine(base_x, base_y+thick, base_x, base_y+thick+length);
        g.drawLine(base_x+thick, base_y+thick, base_x+thick, base_y+thick+length);
        g.drawLine(base_x, base_y+thick, base_x+thick, base_y+thick);
        g.drawLine(base_x, base_y+thick+length, base_x+thick, base_y+thick+length);
        
        g.drawLine(base_x+thick+length, base_y+thick, base_x+thick+length, base_y+thick+length);
        g.drawLine(base_x+thick+length+thick, base_y+thick, base_x+thick+length+thick, base_y+thick+length);
        g.drawLine(base_x+thick+length, base_y+thick, base_x+thick+length+thick, base_y+thick);
        g.drawLine(base_x+thick+length, base_y+thick+length, base_x+thick+length+thick, base_y+thick+length);
        
        g.drawLine(base_x+thick, base_y+thick+length, base_x+thick+length, base_y+thick+length);
        g.drawLine(base_x+thick, base_y+thick+length, base_x+thick, base_y+thick+length+thick);
        g.drawLine(base_x+thick, base_y+thick+length+thick, base_x+thick+length, base_y+thick+length+thick);
        g.drawLine(base_x+thick+length, base_y+thick+length, base_x+thick+length, base_y+thick+length+thick);
        
        g.drawLine(base_x, base_y+thick+length+thick, base_x, base_y+thick+length+thick+length);
        g.drawLine(base_x+thick, base_y+thick+length+thick, base_x+thick, base_y+thick+length+thick+length);
        g.drawLine(base_x, base_y+thick+length+thick, base_x+thick, base_y+thick+length+thick);
        g.drawLine(base_x, base_y+thick+length+thick+length, base_x+thick, base_y+thick+length+thick+length);
        
        g.drawLine(base_x+thick+length, base_y+thick+length+thick, base_x+thick+length, base_y+thick+length+thick+length);
        g.drawLine(base_x+thick+length+thick, base_y+thick+length+thick, base_x+thick+length+thick, base_y+thick+length+thick+length);
        g.drawLine(base_x+thick+length, base_y+thick+length+thick, base_x+thick+length+thick, base_y+thick+length+thick);
        g.drawLine(base_x+thick+length, base_y+thick+length+thick+length, base_x+thick+length+thick, base_y+thick+length+thick+length);
        
        g.drawLine(base_x+thick, base_y+thick+length+thick+length, base_x+thick+length, base_y+thick+length+thick+length);
        g.drawLine(base_x+thick, base_y+thick+length+thick+length, base_x+thick, base_y+thick+length+thick+length+thick);
        g.drawLine(base_x+thick, base_y+thick+length+thick+length+thick, base_x+thick+length, base_y+thick+length+thick+length+thick);
        g.drawLine(base_x+thick+length, base_y+thick+length+thick+length, base_x+thick+length, base_y+thick+length+thick+length+thick);
        
        g.drawLine(base_x+thick+length+thick+thick, base_y+thick+length+thick+length, base_x+thick+length+thick+thick+thick, base_y+thick+length+thick+length);
        g.drawLine(base_x+thick+length+thick+thick, base_y+thick+length+thick+length, base_x+thick+length+thick+thick, base_y+thick+length+thick+length+thick);
        g.drawLine(base_x+thick+length+thick+thick, base_y+thick+length+thick+length+thick, base_x+thick+length+thick+thick+thick, base_y+thick+length+thick+length+thick);
        g.drawLine(base_x+thick+length+thick+thick+thick, base_y+thick+length+thick+length, base_x+thick+length+thick+thick+thick, base_y+thick+length+thick+length+thick);
      
        g.setColor(fill_color);
        
        if(this.state[2][7])
        	g.fillRect(base_x+thick+length+thick+thick, base_y+thick+length+thick+length, thick, thick);	
        if(this.state[2][6])	//a
        	g.fillRect(base_x+thick, base_y, length, thick);
        if(this.state[2][5])	//b
        	g.fillRect(base_x+thick+length, base_y+thick, thick, length);
        if(this.state[2][4])	//c
        	g.fillRect(base_x+thick+length, base_y+thick+length+thick, thick, length);
        if(this.state[2][3])	//d
        	g.fillRect(base_x+thick, base_y+thick+length+thick+length, length, thick);
        if(this.state[2][2])	//e
        	g.fillRect(base_x, base_y+thick+length+thick, thick, length);
        if(this.state[2][1])	//f
        	g.fillRect(base_x, base_y+thick, thick, length);
        if(this.state[2][0])	//g
        	g.fillRect(base_x+thick, base_y+thick+length, length, thick);
    }
    
    @Override
	public void paint(Graphics g) {
    	
    	this.paintComponents(g);
    	
    }
    
    @Override
	public void paintAll(Graphics g) {
    	super.paintComponents(g);
    }
    
    
    public void changeState(int i, boolean[] arr) {
    	this.state[2-i] = arr;
    	
    	
    	
    }
   
    
    
    //SevenSeg seven;
}