// $ANTLR : "den2.g" -> "asmParser.java"$

	package assembler;
	
	import java.io.*;
	import antlr.*;
	import antlr.collections.AST;
	import antlr.debug.misc.ASTFrame;
	import assembler.GenerateHex;
	import gui.ConsolePane;
	import java.util.ArrayList;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import java.util.Hashtable;
import antlr.ASTFactory;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

import java.util.ArrayList;

public class asmParser extends antlr.LLkParser       implements asmLexerTokenTypes
 {

	ArrayList breakPointLineNumbers = null;
	ArrayList breakPointAddresses = new ArrayList();
	
	int passNumber=1;
	int addressNumber=0;
	String HEXString = "";
	int hexword=0;
	SymbolTable sTable = new SymbolTable();
	private int lineNumber = 1; 
	public int getCurrentLine() { return lineNumber;}
	 
	public void setBreakPointLineNumbers(ArrayList bPointLineNo)
	{
		breakPointLineNumbers = bPointLineNo;
	}
	
	/* convert the current line number
		into instruction memory address
	*/
	public void convertBreakPoint(int lineNumber)
	{
		if(breakPointLineNumbers==null)
			return;
		else
		{
			int size = breakPointLineNumbers.size();
			for (int i = 0; i < size ; i++) 
			{
				if(lineNumber == (Integer) breakPointLineNumbers.get(i))
				{
					System.out.println("pass " + passNumber + ": break point on line " + lineNumber + 
						 " is converted to address " + addressNumber);
					breakPointAddresses.add(addressNumber);
				}
				
			}
		}			
	}
	
	public void showBreakPointLineNumbers()
	{
		int size = breakPointLineNumbers.size();
		System.out.println("Break Point Line Numbers on pass" + passNumber + ":");
		for (int i = 0; i < size ; i++) 
		{
			System.out.println(breakPointLineNumbers.get(i));
		}
	}
	
	public void showBreakPointAddresses()
	{
		int size = breakPointAddresses.size();
		System.out.println("Break Point Addresses:");
		for (int i = 0; i < size ; i++) 
		{
			System.out.println(breakPointAddresses.get(i));
		}
	
	}
	
	
	public SymbolTable getSTable() {
		return sTable;
	}
	
	public void setSTable(SymbolTable sT) {
		sTable = sT;
		sTable.printTable();
	}
	
	public void Initialize(int pNum)
	{
		addressNumber=0;
		HEXString = "";
		hexword=0;
		passNumber = pNum;
	}
	
	public int str2int(String str)
	{
			String tempval="";
			int data=0;

			if((str.length() > 1)&& (str.charAt(1)=='x'))
			{	
				//hex
				tempval = str.substring(2);
				data = Integer.parseInt(tempval, 16);
			}else if((str.charAt(0)=='b') | (str.charAt(0)=='B'))
			{ //binary
				tempval = str.substring(2, str.length()-1);
				/*System.out.println("BINARY:"+tempval);*/
				data = Integer.parseInt(tempval, 2);
				
			}else
			{
				if((str.charAt(0)=='d') | (str.charAt(0)=='D'))
				{ //D'10'
					tempval = str.substring(2, str.length()-1);
					data = Integer.parseInt(tempval, 10);
				
				}else //standard decimal
					data = Integer.parseInt(str);
			}
			
			return data;
	}
	public class Symbol {
		private String name;
		private int value;
		
		Symbol (String nm, int val) {
			name = nm;
			value = val;
		}
			
		public void printSymbol() {
			/*System.out.println("|\t"+name+"\t\t"+value+"\t|");
			System.out.println("+--------------------------------+");*/
		}
	}
	
	public class SymbolTable {
		private ArrayList sTable;
		
		SymbolTable () {
			sTable = new ArrayList();
			
			// Kucuk harf versiyonlari da eklenecek:
			//BANK0
			add("TMR0", "1");
			add("PCL", "2");
			add("STATUS", "3");
				add("RP1", "6");
				add("RP0", "5");
			add("FSR", "4");
			add("PORTA", "5");
			add("PORTB", "6");
			add("PORTC", "7");
			add("PORTD", "8");
			add("PORTE", "9");
			add("PCLATH", "10");
			add("INTCON", "11");
			add("PIR1", "12");
			add("PIR2", "13");
			add("TMR1L", "14");
			add("TMR1H", "15");
			add("T1CON", "16");
			add("TMR2", "17");
			add("T2CON", "18");
			add("SSPBUF", "19");
			add("SSPCON", "20");
			add("CCPR1L", "21");
			add("CCPR1H", "22");
			add("CCP1CON", "23");
			add("RCSTA", "24");
			add("TXREG", "25");
			add("RCREG", "26");
			add("CCPR2L", "27");
			add("CCPR2H", "28");
			add("CCP2CON", "29");
			add("ADRESH", "30");
			add("ADCON0", "31");
			
			//BANK1
			add("OPTION_REG", "1");
			add("TRISA", "5");
			add("TRISB", "6");
			add("TRISC", "7");
			add("TRISD", "8");
			add("TRISE", "9");
			add("PCLATH", "10");
			add("INTCON", "11");
			add("PIE1", "12");
			add("PIE2", "13");
			add("PCON", "14");
			add("SSPCON2", "17");
			add("PR2", "18");
			add("SSPADD", "19");
			add("SSPSTAT", "20");
			add("TXSTA", "24");
			add("SPBRG", "25");
			add("ADRESL", "30");
			add("ADCON1", "31");

			//BANK2
			add("EEDATA", "12");
			add("EEADR", "13");
			add("EEDATH", "14");
			add("EEADRH", "15");

			//BANK3
			add("EECON1", "12");
			add("EECON2", "13");
		}
	  
		
		public void add(String name, String value) {
			String tempval="";
			int data=0;

			data = str2int(value);
			
			Symbol sym = new Symbol(name, data);
			sTable.add(sym);
		}
		
		public int getSize() {
			return sTable.size();
		}
		
		public Symbol getSymbol(int i) {
			return (Symbol)sTable.get(i);
		}

		public int getSymbolValue(String s_name) {
			int size = sTable.size();
			Symbol entry = null;
			for (int i = 0; i < size; i++) {
				entry = (Symbol)sTable.get(i);
				if(s_name.compareTo(entry.name) == 0) {
				  return entry.value;
				}
			}
			//Print an error here, there is no such variable 
			return -1;
			
		} 
	
		public boolean isDefined (String s_name) {
			int size = sTable.size();
			for (int i = 0; i < size; i++) {
				Symbol entry = (Symbol)sTable.get(i);
				if((s_name.compareTo(entry.name) == 0)) 
				{
				   	return true;
				}
			}
			return false;
		}
				

		public void printTable() {
			/*System.out.println("+------- SYMBOL TABLE  ----------+");
			System.out.println("|\tNAME"+"\t\t"+"VALUE\t|");
			System.out.println("+--------------------------------+");
			*/
			for (int i = 0; i < sTable.size(); i++) {
				getSymbol(i).printSymbol();
			}
		}
	}

protected asmParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public asmParser(TokenBuffer tokenBuf) {
  this(tokenBuf,2);
}

protected asmParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public asmParser(TokenStream lexer) {
  this(lexer,2);
}

public asmParser(ParserSharedInputState state) {
  super(state,2);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

	public final String  program() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST program_AST = null;
		
		String s1=""; /*System.out.println("program");*/
		{
		{
		_loop2200:
		do {
			if ((LA(1)==NEWLINE)) {
				match(NEWLINE);
				lineNumber++;
			}
			else {
				break _loop2200;
			}
			
		} while (true);
		}
		s1=subprogramBody();
		astFactory.addASTChild(currentAST, returnAST);
		}
		
					s+=s1;
					/*System.out.println("end program");
					System.out.println("pass " + passNumber + " completed.");	
					//s+= "endprg\n";
					*/
				
		program_AST = (AST)currentAST.root;
		returnAST = program_AST;
		return s;
	}
	
	public final String  subprogramBody() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST subprogramBody_AST = null;
		
		
				String s2="";
			
		{
		{
		_loop2206:
		do {
			if ((LA(1)==IDENT) && (LA(2)==EQU)) {
				basicDecl();
				astFactory.addASTChild(currentAST, returnAST);
				addressNumber++;/*System.out.println(addressNumber);*/
				{
				int _cnt2205=0;
				_loop2205:
				do {
					if ((LA(1)==NEWLINE)) {
						match(NEWLINE);
						lineNumber++;
					}
					else {
						if ( _cnt2205>=1 ) { break _loop2205; } else {throw new NoViableAltException(LT(1), getFilename());}
					}
					
					_cnt2205++;
				} while (true);
				}
			}
			else {
				break _loop2206;
			}
			
		} while (true);
		}
		{
		_loop2210:
		do {
			if ((_tokenSet_0.member(LA(1)))) {
				s2=statement();
				astFactory.addASTChild(currentAST, returnAST);
					convertBreakPoint(getCurrentLine());
												addressNumber++;s+=s2;/*System.out.println(addressNumber);*/
				
											
				{
				int _cnt2209=0;
				_loop2209:
				do {
					if ((LA(1)==NEWLINE)) {
						match(NEWLINE);
						{lineNumber++;}s+="\n";
					}
					else {
						if ( _cnt2209>=1 ) { break _loop2209; } else {throw new NoViableAltException(LT(1), getFilename());}
					}
					
					_cnt2209++;
				} while (true);
				}
			}
			else {
				break _loop2210;
			}
			
		} while (true);
		}
		{
		switch ( LA(1)) {
		case END:
		{
			AST tmp4_AST = null;
			tmp4_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp4_AST);
			match(END);
			break;
		}
		case EOF:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					//System.out.println("matched subp");
					//#subprogramBody = #([SUBPROGRAMBODY,"subprogramBody"], #subprogramBody);
				
		subprogramBody_AST = (AST)currentAST.root;
		returnAST = subprogramBody_AST;
		return s;
	}
	
	public final void basicDecl() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST basicDecl_AST = null;
		
		{
		constDecl();
		astFactory.addASTChild(currentAST, returnAST);
		}
		
					
				
		basicDecl_AST = (AST)currentAST.root;
		returnAST = basicDecl_AST;
	}
	
	public final String  statement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST statement_AST = null;
		
		{
		switch ( LA(1)) {
		case ADDWF:
		case ANDWF:
		case CLRF:
		case CLRW:
		case COMF:
		case DECF:
		case DECFSZ:
		case INCF:
		case INCFSZ:
		case IORWF:
		case MOVF:
		case MOVWF:
		case NOP:
		case RLF:
		case RRF:
		case SUBWF:
		case SWAPF:
		case XORWF:
		case BCF:
		case BSF:
		case BTFSC:
		case BTFSS:
		case ADDLW:
		case ANDLW:
		case CALL:
		case CLRWDT:
		case GOTO:
		case IORLW:
		case MOVLW:
		case RETFIE:
		case RETLW:
		case RETURN:
		case SLEEP:
		case SUBLW:
		case XORLW:
		{
			s=instructionStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case ORG:
		{
			s=orgStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case IDENT:
		{
			s=labelStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		
				
		statement_AST = (AST)currentAST.root;
		returnAST = statement_AST;
		return s;
	}
	
	public final void constDecl() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST constDecl_AST = null;
		Token  id = null;
		AST id_AST = null;
		Token  num = null;
		AST num_AST = null;
		
		{
		id = LT(1);
		id_AST = astFactory.create(id);
		astFactory.addASTChild(currentAST, id_AST);
		match(IDENT);
		match(EQU);
		num = LT(1);
		num_AST = astFactory.create(num);
		astFactory.addASTChild(currentAST, num_AST);
		match(NUMBER);
		}
		
					sTable.add(id.getText(), num.getText());
					sTable.printTable();
					addressNumber--;
				
		constDecl_AST = (AST)currentAST.root;
		returnAST = constDecl_AST;
	}
	
	public final String  instructionStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST instructionStatement_AST = null;
		
		{
		s=asmStatement();
		astFactory.addASTChild(currentAST, returnAST);
		}
		
				
		instructionStatement_AST = (AST)currentAST.root;
		returnAST = instructionStatement_AST;
		return s;
	}
	
	public final String  orgStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST orgStatement_AST = null;
		Token  num = null;
		AST num_AST = null;
		Token  id = null;
		AST id_AST = null;
		
		
					String pass1="";
					String addr="";
				
		{
		match(ORG);
		pass1+="org ";
		{
		switch ( LA(1)) {
		case NUMBER:
		{
			num = LT(1);
			num_AST = astFactory.create(num);
			astFactory.addASTChild(currentAST, num_AST);
			match(NUMBER);
			addr=num.getText();pass1+=num.getText();
			break;
		}
		case IDENT:
		{
			id = LT(1);
			id_AST = astFactory.create(id);
			astFactory.addASTChild(currentAST, id_AST);
			match(IDENT);
			addr=""+sTable.getSymbolValue(id.getText());pass1+=id.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					addressNumber = str2int(addr);
								
					/*System.out.println("orgStatement " + addressNumber);*/
					// Modify the addressNumber with the contents of the NUMBER or IDENT=constant 
						
					
						
					s += "\n";
					s += Integer.toString(addressNumber, 16);
					s += ":\n";		
					
					addressNumber--; // ORG Statement does not occupy address in the memory, so reduce the address by 1
					
					if(passNumber==1)
						s = pass1;
				
		orgStatement_AST = (AST)currentAST.root;
		returnAST = orgStatement_AST;
		return s;
	}
	
	public final String  labelStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST labelStatement_AST = null;
		Token  id = null;
		AST id_AST = null;
		Token  id2 = null;
		AST id2_AST = null;
		
		if ((LA(1)==IDENT) && (LA(2)==COLON)) {
			{
			{
			id = LT(1);
			id_AST = astFactory.create(id);
			astFactory.addASTChild(currentAST, id_AST);
			match(IDENT);
			match(COLON);
			}
			
							// insert the label and the addressNumber to the labelTable
							if(passNumber==1)
								sTable.add(id.getText(), Integer.toString(addressNumber));
							sTable.printTable();
							
							
							/*System.out.println("labelStatement");*/
							if(passNumber==1)
								s += id.getText() + ":\n";
							else
								s += Integer.toString(addressNumber, 16) + ":\n";
							
							addressNumber--;
						
			}
			labelStatement_AST = (AST)currentAST.root;
		}
		else if ((LA(1)==IDENT) && (LA(2)==NEWLINE)) {
			{
			id2 = LT(1);
			id2_AST = astFactory.create(id2);
			astFactory.addASTChild(currentAST, id2_AST);
			match(IDENT);
			}
			
							// insert the label and the addressNumber to the labelTable
							if(passNumber==1)
								sTable.add(id2.getText(), Integer.toString(addressNumber));
							sTable.printTable();
							
							
							/*System.out.println("labelStatement");*/
							if(passNumber==1)
								s += id2.getText() + ":\n";
							else
								s += Integer.toString(addressNumber, 16) + ":\n";
							
							addressNumber--;
						
			labelStatement_AST = (AST)currentAST.root;
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		returnAST = labelStatement_AST;
		return s;
	}
	
	public final String  asmStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST asmStatement_AST = null;
		
		{
		switch ( LA(1)) {
		case ADDWF:
		{
			s=addwfStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case ANDWF:
		{
			s=andwfStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case CLRF:
		{
			s=clrfStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case CLRW:
		{
			s=clrwStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case COMF:
		{
			s=comfStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case DECF:
		{
			s=decfStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case DECFSZ:
		{
			s=decfszStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case INCF:
		{
			s=incfStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case INCFSZ:
		{
			s=incfszStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case IORWF:
		{
			s=iorwfStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case MOVF:
		{
			s=movfStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case MOVWF:
		{
			s=movwfStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case NOP:
		{
			s=nopStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case RLF:
		{
			s=rlfStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case RRF:
		{
			s=rrfStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case SUBWF:
		{
			s=subwfStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case SWAPF:
		{
			s=swapfStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case XORWF:
		{
			s=xorwfStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case BCF:
		{
			s=bcfStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case BSF:
		{
			s=bsfStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case BTFSC:
		{
			s=btfscStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case BTFSS:
		{
			s=btfssStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case ADDLW:
		{
			s=addlwStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case ANDLW:
		{
			s=andlwStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case CALL:
		{
			s=callStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case CLRWDT:
		{
			s=clrwdtStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case GOTO:
		{
			s=gotoStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case IORLW:
		{
			s=iorlwStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case MOVLW:
		{
			s=movlwStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case RETFIE:
		{
			s=retfieStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case RETLW:
		{
			s=retlwStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case RETURN:
		{
			s=returnStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case SLEEP:
		{
			s=sleepStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case SUBLW:
		{
			s=sublwStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		case XORLW:
		{
			s=xorlwStatement();
			astFactory.addASTChild(currentAST, returnAST);
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		
					
				
		asmStatement_AST = (AST)currentAST.root;
		returnAST = asmStatement_AST;
		return s;
	}
	
	public final String  addwfStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST addwfStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		Token  id2 = null;
		AST id2_AST = null;
		Token  num2 = null;
		AST num2_AST = null;
		
		
					int arg1=0;
					int arg2=1;
					String pass1="";
				
		{
		match(ADDWF);
		pass1+="addwf ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case COMMA:
		{
			match(COMMA);
			pass1+=",";
			{
			switch ( LA(1)) {
			case IDENT:
			{
				id2 = LT(1);
				id2_AST = astFactory.create(id2);
				astFactory.addASTChild(currentAST, id2_AST);
				match(IDENT);
				arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();
				break;
			}
			case NUMBER:
			{
				num2 = LT(1);
				num2_AST = astFactory.create(num2);
				astFactory.addASTChild(currentAST, num2_AST);
				match(NUMBER);
				arg2 = str2int(num2.getText());pass1+=num2.getText();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case NEWLINE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					
					if((arg1>0x3F) || (arg2 > 1))
						System.out.println("ERROR!!!!!");
						
						
					hexword = 0x0700;
					hexword += arg2 * 0x0080; 
					hexword += arg1; 
			
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
									
					/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
					
					if(passNumber==1)
						s = pass1;
				
		addwfStatement_AST = (AST)currentAST.root;
		returnAST = addwfStatement_AST;
		return s;
	}
	
	public final String  andwfStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST andwfStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		Token  id2 = null;
		AST id2_AST = null;
		Token  num2 = null;
		AST num2_AST = null;
		
		
					String pass1="";
					int arg1=0;
					int arg2=1;
				
		{
		match(ANDWF);
		pass1+="andwf ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case COMMA:
		{
			match(COMMA);
			pass1+=",";
			{
			switch ( LA(1)) {
			case IDENT:
			{
				id2 = LT(1);
				id2_AST = astFactory.create(id2);
				astFactory.addASTChild(currentAST, id2_AST);
				match(IDENT);
				arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();
				break;
			}
			case NUMBER:
			{
				num2 = LT(1);
				num2_AST = astFactory.create(num2);
				astFactory.addASTChild(currentAST, num2_AST);
				match(NUMBER);
				arg2 = str2int(num2.getText());pass1+=num2.getText();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case NEWLINE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0x3F) || (arg2 > 1))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x0500;
					hexword += arg2 * 0x0080; 
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		andwfStatement_AST = (AST)currentAST.root;
		returnAST = andwfStatement_AST;
		return s;
	}
	
	public final String  clrfStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST clrfStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		
		
					String pass1="";
					int arg1=0;
				
		{
		match(CLRF);
		pass1+="clrf ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0x3F))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x0180;
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		clrfStatement_AST = (AST)currentAST.root;
		returnAST = clrfStatement_AST;
		return s;
	}
	
	public final String  clrwStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST clrwStatement_AST = null;
		
		
					String pass1="";	
				
		{
		match(CLRW);
		pass1+="clrw ";
		}
		
					hexword = 0x0100;
					
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		clrwStatement_AST = (AST)currentAST.root;
		returnAST = clrwStatement_AST;
		return s;
	}
	
	public final String  comfStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST comfStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		Token  id2 = null;
		AST id2_AST = null;
		Token  num2 = null;
		AST num2_AST = null;
		
		
					String pass1="";
					int arg1=0;
					int arg2=1;
				
		{
		match(COMF);
		pass1+="comf ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case COMMA:
		{
			match(COMMA);
			pass1+=",";
			{
			switch ( LA(1)) {
			case IDENT:
			{
				id2 = LT(1);
				id2_AST = astFactory.create(id2);
				astFactory.addASTChild(currentAST, id2_AST);
				match(IDENT);
				arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();
				break;
			}
			case NUMBER:
			{
				num2 = LT(1);
				num2_AST = astFactory.create(num2);
				astFactory.addASTChild(currentAST, num2_AST);
				match(NUMBER);
				arg2 = str2int(num2.getText());pass1+=num2.getText();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case NEWLINE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0x3F) || (arg2 > 1))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x0900;
					hexword += arg2 * 0x0080; 
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
		/*			System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		comfStatement_AST = (AST)currentAST.root;
		returnAST = comfStatement_AST;
		return s;
	}
	
	public final String  decfStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST decfStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		Token  id2 = null;
		AST id2_AST = null;
		Token  num2 = null;
		AST num2_AST = null;
		
		
					String pass1="";
					int arg1=0;
					int arg2=1;
				
		{
		match(DECF);
		pass1+="decf ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case COMMA:
		{
			match(COMMA);
			pass1+=",";
			{
			switch ( LA(1)) {
			case IDENT:
			{
				id2 = LT(1);
				id2_AST = astFactory.create(id2);
				astFactory.addASTChild(currentAST, id2_AST);
				match(IDENT);
				arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();
				break;
			}
			case NUMBER:
			{
				num2 = LT(1);
				num2_AST = astFactory.create(num2);
				astFactory.addASTChild(currentAST, num2_AST);
				match(NUMBER);
				arg2 = str2int(num2.getText());pass1+=num2.getText();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case NEWLINE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0x7F) || (arg2 > 1))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x0300;
					hexword += arg2 * 0x0080; 
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		decfStatement_AST = (AST)currentAST.root;
		returnAST = decfStatement_AST;
		return s;
	}
	
	public final String  decfszStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST decfszStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		Token  id2 = null;
		AST id2_AST = null;
		Token  num2 = null;
		AST num2_AST = null;
		
		
					String pass1="";
					int arg1=0;
					int arg2=1;
				
		{
		match(DECFSZ);
		pass1+="decfsz ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case COMMA:
		{
			match(COMMA);
			pass1+=",";
			{
			switch ( LA(1)) {
			case IDENT:
			{
				id2 = LT(1);
				id2_AST = astFactory.create(id2);
				astFactory.addASTChild(currentAST, id2_AST);
				match(IDENT);
				arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();
				break;
			}
			case NUMBER:
			{
				num2 = LT(1);
				num2_AST = astFactory.create(num2);
				astFactory.addASTChild(currentAST, num2_AST);
				match(NUMBER);
				arg2 = str2int(num2.getText());pass1+=num2.getText();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case NEWLINE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0x7F) || (arg2 > 1))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x0B00;
					hexword += arg2 * 0x0080; 
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		decfszStatement_AST = (AST)currentAST.root;
		returnAST = decfszStatement_AST;
		return s;
	}
	
	public final String  incfStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST incfStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		Token  id2 = null;
		AST id2_AST = null;
		Token  num2 = null;
		AST num2_AST = null;
		
		
					String pass1="";
					int arg1=0;
					int arg2=1;
				
		{
		match(INCF);
		pass1+="incf ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case COMMA:
		{
			match(COMMA);
			pass1+=",";
			{
			switch ( LA(1)) {
			case IDENT:
			{
				id2 = LT(1);
				id2_AST = astFactory.create(id2);
				astFactory.addASTChild(currentAST, id2_AST);
				match(IDENT);
				arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();
				break;
			}
			case NUMBER:
			{
				num2 = LT(1);
				num2_AST = astFactory.create(num2);
				astFactory.addASTChild(currentAST, num2_AST);
				match(NUMBER);
				arg2 = str2int(num2.getText());pass1+=num2.getText();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case NEWLINE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0x7F) || (arg2 > 1))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x0A00;
					hexword += arg2 * 0x0080; 
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		incfStatement_AST = (AST)currentAST.root;
		returnAST = incfStatement_AST;
		return s;
	}
	
	public final String  incfszStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST incfszStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		Token  id2 = null;
		AST id2_AST = null;
		Token  num2 = null;
		AST num2_AST = null;
		
		
					String pass1="";
					int arg1=0;
					int arg2=1;
				
		{
		match(INCFSZ);
		pass1+="incfsz ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case COMMA:
		{
			match(COMMA);
			pass1+=",";
			{
			switch ( LA(1)) {
			case IDENT:
			{
				id2 = LT(1);
				id2_AST = astFactory.create(id2);
				astFactory.addASTChild(currentAST, id2_AST);
				match(IDENT);
				arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();
				break;
			}
			case NUMBER:
			{
				num2 = LT(1);
				num2_AST = astFactory.create(num2);
				astFactory.addASTChild(currentAST, num2_AST);
				match(NUMBER);
				arg2 = str2int(num2.getText());pass1+=num2.getText();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case NEWLINE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0x7F) || (arg2 > 1))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x0F00;
					hexword += arg2 * 0x0080; 
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		incfszStatement_AST = (AST)currentAST.root;
		returnAST = incfszStatement_AST;
		return s;
	}
	
	public final String  iorwfStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST iorwfStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		Token  id2 = null;
		AST id2_AST = null;
		Token  num2 = null;
		AST num2_AST = null;
		
		
					String pass1="";
					int arg1=0;
					int arg2=1;
				
		{
		match(IORWF);
		pass1+="iorwf ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case COMMA:
		{
			match(COMMA);
			pass1+=",";
			{
			switch ( LA(1)) {
			case IDENT:
			{
				id2 = LT(1);
				id2_AST = astFactory.create(id2);
				astFactory.addASTChild(currentAST, id2_AST);
				match(IDENT);
				arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();
				break;
			}
			case NUMBER:
			{
				num2 = LT(1);
				num2_AST = astFactory.create(num2);
				astFactory.addASTChild(currentAST, num2_AST);
				match(NUMBER);
				arg2 = str2int(num2.getText());pass1+=num2.getText();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case NEWLINE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0x7F) || (arg2 > 1))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x0400;
					hexword += arg2 * 0x0080; 
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		iorwfStatement_AST = (AST)currentAST.root;
		returnAST = iorwfStatement_AST;
		return s;
	}
	
	public final String  movfStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST movfStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		Token  id2 = null;
		AST id2_AST = null;
		Token  num2 = null;
		AST num2_AST = null;
		
		
					String pass1="";
					int arg1=0;
					int arg2=1;
				
		{
		match(MOVF);
		pass1+="movf ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case COMMA:
		{
			match(COMMA);
			pass1+=",";
			{
			switch ( LA(1)) {
			case IDENT:
			{
				id2 = LT(1);
				id2_AST = astFactory.create(id2);
				astFactory.addASTChild(currentAST, id2_AST);
				match(IDENT);
				arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();
				break;
			}
			case NUMBER:
			{
				num2 = LT(1);
				num2_AST = astFactory.create(num2);
				astFactory.addASTChild(currentAST, num2_AST);
				match(NUMBER);
				arg2 = str2int(num2.getText());pass1+=num2.getText();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case NEWLINE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0x7F) || (arg2 > 1))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x0800;
					hexword += arg2 * 0x0080; 
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		movfStatement_AST = (AST)currentAST.root;
		returnAST = movfStatement_AST;
		return s;
	}
	
	public final String  movwfStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST movwfStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		
		
					String pass1="";
					int arg1=0;
				
		{
		match(MOVWF);
		pass1+="movwf ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0x7F))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x0080;
					hexword += arg1; 
					//System.out.println("HEX " + arg1 + " " + hexword);
					
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					//System.out.println("HEX " + arg1 + " " + HEXString);
					if(passNumber==1)
						s = pass1;
				
		movwfStatement_AST = (AST)currentAST.root;
		returnAST = movwfStatement_AST;
		return s;
	}
	
	public final String  nopStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST nopStatement_AST = null;
		
		
					String pass1="";
				
		{
		match(NOP);
		pass1+="nop ";
		}
		
					hexword = 0x0000;
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		nopStatement_AST = (AST)currentAST.root;
		returnAST = nopStatement_AST;
		return s;
	}
	
	public final String  rlfStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST rlfStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		Token  id2 = null;
		AST id2_AST = null;
		Token  num2 = null;
		AST num2_AST = null;
		
		
					String pass1="";
					int arg1=0;
					int arg2=1;
				
		{
		match(RLF);
		pass1+="rlf ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case COMMA:
		{
			match(COMMA);
			pass1+=",";
			{
			switch ( LA(1)) {
			case IDENT:
			{
				id2 = LT(1);
				id2_AST = astFactory.create(id2);
				astFactory.addASTChild(currentAST, id2_AST);
				match(IDENT);
				arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();
				break;
			}
			case NUMBER:
			{
				num2 = LT(1);
				num2_AST = astFactory.create(num2);
				astFactory.addASTChild(currentAST, num2_AST);
				match(NUMBER);
				arg2 = str2int(num2.getText());pass1+=num2.getText();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case NEWLINE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0x7F) || (arg2 > 1))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x0D00;
					hexword += arg2 * 0x0080; 
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		rlfStatement_AST = (AST)currentAST.root;
		returnAST = rlfStatement_AST;
		return s;
	}
	
	public final String  rrfStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST rrfStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		Token  id2 = null;
		AST id2_AST = null;
		Token  num2 = null;
		AST num2_AST = null;
		
		
					String pass1="";
					int arg1=0;
					int arg2=1;
				
		{
		match(RRF);
		pass1+="rrf ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case COMMA:
		{
			match(COMMA);
			pass1+=",";
			{
			switch ( LA(1)) {
			case IDENT:
			{
				id2 = LT(1);
				id2_AST = astFactory.create(id2);
				astFactory.addASTChild(currentAST, id2_AST);
				match(IDENT);
				arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();
				break;
			}
			case NUMBER:
			{
				num2 = LT(1);
				num2_AST = astFactory.create(num2);
				astFactory.addASTChild(currentAST, num2_AST);
				match(NUMBER);
				arg2 = str2int(num2.getText());pass1+=num2.getText();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case NEWLINE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0x7F) || (arg2 > 1))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x0C00;
					hexword += arg2 * 0x0080; 
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		rrfStatement_AST = (AST)currentAST.root;
		returnAST = rrfStatement_AST;
		return s;
	}
	
	public final String  subwfStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST subwfStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		Token  id2 = null;
		AST id2_AST = null;
		Token  num2 = null;
		AST num2_AST = null;
		
		
					String pass1="";
					int arg1=0;
					int arg2=1;
				
		{
		match(SUBWF);
		pass1+="subwf ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case COMMA:
		{
			match(COMMA);
			pass1+=",";
			{
			switch ( LA(1)) {
			case IDENT:
			{
				id2 = LT(1);
				id2_AST = astFactory.create(id2);
				astFactory.addASTChild(currentAST, id2_AST);
				match(IDENT);
				arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();
				break;
			}
			case NUMBER:
			{
				num2 = LT(1);
				num2_AST = astFactory.create(num2);
				astFactory.addASTChild(currentAST, num2_AST);
				match(NUMBER);
				arg2 = str2int(num2.getText());pass1+=num2.getText();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case NEWLINE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0x7F) || (arg2 > 1))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x0200;
					hexword += arg2 * 0x0080; 
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		subwfStatement_AST = (AST)currentAST.root;
		returnAST = subwfStatement_AST;
		return s;
	}
	
	public final String  swapfStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST swapfStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		Token  id2 = null;
		AST id2_AST = null;
		Token  num2 = null;
		AST num2_AST = null;
		
		
					String pass1="";
					int arg1=0;
					int arg2=1;
				
		{
		match(SWAPF);
		pass1+="swapf ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case COMMA:
		{
			match(COMMA);
			pass1+=",";
			{
			switch ( LA(1)) {
			case IDENT:
			{
				id2 = LT(1);
				id2_AST = astFactory.create(id2);
				astFactory.addASTChild(currentAST, id2_AST);
				match(IDENT);
				arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();
				break;
			}
			case NUMBER:
			{
				num2 = LT(1);
				num2_AST = astFactory.create(num2);
				astFactory.addASTChild(currentAST, num2_AST);
				match(NUMBER);
				arg2 = str2int(num2.getText());pass1+=num2.getText();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case NEWLINE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0x7F) || (arg2 > 1))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x0E00;
					hexword += arg2 * 0x0080; 
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		swapfStatement_AST = (AST)currentAST.root;
		returnAST = swapfStatement_AST;
		return s;
	}
	
	public final String  xorwfStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST xorwfStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		Token  id2 = null;
		AST id2_AST = null;
		Token  num2 = null;
		AST num2_AST = null;
		
		
					String pass1="";
					int arg1=0;
					int arg2=1;
				
		{
		match(XORWF);
		pass1+="xorwf ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case COMMA:
		{
			match(COMMA);
			pass1+=",";
			{
			switch ( LA(1)) {
			case IDENT:
			{
				id2 = LT(1);
				id2_AST = astFactory.create(id2);
				astFactory.addASTChild(currentAST, id2_AST);
				match(IDENT);
				arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();
				break;
			}
			case NUMBER:
			{
				num2 = LT(1);
				num2_AST = astFactory.create(num2);
				astFactory.addASTChild(currentAST, num2_AST);
				match(NUMBER);
				arg2 = str2int(num2.getText());pass1+=num2.getText();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case NEWLINE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0x7F) || (arg2 > 1))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x0600;
					hexword += arg2 * 0x0080; 
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		xorwfStatement_AST = (AST)currentAST.root;
		returnAST = xorwfStatement_AST;
		return s;
	}
	
	public final String  bcfStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST bcfStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		Token  id2 = null;
		AST id2_AST = null;
		Token  num2 = null;
		AST num2_AST = null;
		
		
					String pass1="";
					int arg1=0;
					int arg2=0;
				
		{
		match(BCF);
		pass1+="bcf ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case COMMA:
		{
			match(COMMA);
			pass1+=",";
			{
			switch ( LA(1)) {
			case IDENT:
			{
				id2 = LT(1);
				id2_AST = astFactory.create(id2);
				astFactory.addASTChild(currentAST, id2_AST);
				match(IDENT);
				arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();
				break;
			}
			case NUMBER:
			{
				num2 = LT(1);
				num2_AST = astFactory.create(num2);
				astFactory.addASTChild(currentAST, num2_AST);
				match(NUMBER);
				arg2 = str2int(num2.getText());pass1+=num2.getText();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case NEWLINE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0x7F) || (arg2 > 7))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x1000;
					hexword += arg2 * 0x0080; 
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		bcfStatement_AST = (AST)currentAST.root;
		returnAST = bcfStatement_AST;
		return s;
	}
	
	public final String  bsfStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST bsfStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		Token  id2 = null;
		AST id2_AST = null;
		Token  num2 = null;
		AST num2_AST = null;
		
		
					String pass1="";
					int arg1=0;
					int arg2=0;
				
		{
		match(BSF);
		pass1+="bsf ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case COMMA:
		{
			match(COMMA);
			pass1+=",";
			{
			switch ( LA(1)) {
			case IDENT:
			{
				id2 = LT(1);
				id2_AST = astFactory.create(id2);
				astFactory.addASTChild(currentAST, id2_AST);
				match(IDENT);
				arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();
				break;
			}
			case NUMBER:
			{
				num2 = LT(1);
				num2_AST = astFactory.create(num2);
				astFactory.addASTChild(currentAST, num2_AST);
				match(NUMBER);
				arg2 = str2int(num2.getText());pass1+=num2.getText();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case NEWLINE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0x7F) || (arg2 > 7))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x1400;
					hexword += arg2 * 0x0080; 
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		bsfStatement_AST = (AST)currentAST.root;
		returnAST = bsfStatement_AST;
		return s;
	}
	
	public final String  btfscStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST btfscStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		Token  id2 = null;
		AST id2_AST = null;
		Token  num2 = null;
		AST num2_AST = null;
		
		
					String pass1="";
					int arg1=0;
					int arg2=0;
				
		{
		match(BTFSC);
		pass1+="btfsc ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case COMMA:
		{
			match(COMMA);
			pass1+=",";
			{
			switch ( LA(1)) {
			case IDENT:
			{
				id2 = LT(1);
				id2_AST = astFactory.create(id2);
				astFactory.addASTChild(currentAST, id2_AST);
				match(IDENT);
				arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();
				break;
			}
			case NUMBER:
			{
				num2 = LT(1);
				num2_AST = astFactory.create(num2);
				astFactory.addASTChild(currentAST, num2_AST);
				match(NUMBER);
				arg2 = str2int(num2.getText());pass1+=num2.getText();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case NEWLINE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0x7F) || (arg2 > 7))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x1800;
					hexword += arg2 * 0x0080; 
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		btfscStatement_AST = (AST)currentAST.root;
		returnAST = btfscStatement_AST;
		return s;
	}
	
	public final String  btfssStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST btfssStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		Token  id2 = null;
		AST id2_AST = null;
		Token  num2 = null;
		AST num2_AST = null;
		
		
					String pass1="";
					int arg1=0;
					int arg2=0;
				
		{
		match(BTFSS);
		pass1+="btfss ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case COMMA:
		{
			match(COMMA);
			pass1+=",";
			{
			switch ( LA(1)) {
			case IDENT:
			{
				id2 = LT(1);
				id2_AST = astFactory.create(id2);
				astFactory.addASTChild(currentAST, id2_AST);
				match(IDENT);
				arg2 = sTable.getSymbolValue(id2.getText());pass1+=id2.getText();
				break;
			}
			case NUMBER:
			{
				num2 = LT(1);
				num2_AST = astFactory.create(num2);
				astFactory.addASTChild(currentAST, num2_AST);
				match(NUMBER);
				arg2 = str2int(num2.getText());pass1+=num2.getText();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case NEWLINE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0x7F) || (arg2 > 7))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x1C00;
					hexword += arg2 * 0x0080; 
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + arg2 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		btfssStatement_AST = (AST)currentAST.root;
		returnAST = btfssStatement_AST;
		return s;
	}
	
	public final String  addlwStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST addlwStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		
		
					String pass1="";
					int arg1=0;
				
		{
		match(ADDLW);
		pass1+="addlw ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0xFF))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x3F00;
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		addlwStatement_AST = (AST)currentAST.root;
		returnAST = addlwStatement_AST;
		return s;
	}
	
	public final String  andlwStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST andlwStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		
		
					String pass1="";
					int arg1=0;
				
		{
		match(ANDLW);
		pass1+="andlw ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0xFF))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x3900;
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		andlwStatement_AST = (AST)currentAST.root;
		returnAST = andlwStatement_AST;
		return s;
	}
	
	public final String  callStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST callStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		
		
					String pass1="";
					int arg1=0;
				
		{
		match(CALL);
		pass1+="call ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0x3FF))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x2000;
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		callStatement_AST = (AST)currentAST.root;
		returnAST = callStatement_AST;
		return s;
	}
	
	public final String  clrwdtStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST clrwdtStatement_AST = null;
		
		
					String pass1="";	
				
		{
		match(CLRWDT);
		pass1+="clrwdt ";
		}
		
					
					hexword = 0x0064;
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		clrwdtStatement_AST = (AST)currentAST.root;
		returnAST = clrwdtStatement_AST;
		return s;
	}
	
	public final String  gotoStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST gotoStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		
		
					String pass1="";
					int arg1=0;
				
		{
		match(GOTO);
		pass1+="goto ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0x3FF))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x2800;
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		gotoStatement_AST = (AST)currentAST.root;
		returnAST = gotoStatement_AST;
		return s;
	}
	
	public final String  iorlwStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST iorlwStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		
		
					String pass1="";
					int arg1=0;
				
		{
		match(IORLW);
		pass1+="goto ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0xFF))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x3800;
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		iorlwStatement_AST = (AST)currentAST.root;
		returnAST = iorlwStatement_AST;
		return s;
	}
	
	public final String  movlwStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST movlwStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		
		
					String pass1="";
					int arg1=0;
				
		{
		match(MOVLW);
		pass1+="movlw ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					
					if((arg1>0xFF))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x3000;
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		movlwStatement_AST = (AST)currentAST.root;
		returnAST = movlwStatement_AST;
		return s;
	}
	
	public final String  retfieStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST retfieStatement_AST = null;
		
		
				String pass1="";
				
		{
		match(RETFIE);
		pass1+="retfie ";
		}
		
					
					hexword = 0x0009;
					
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		retfieStatement_AST = (AST)currentAST.root;
		returnAST = retfieStatement_AST;
		return s;
	}
	
	public final String  retlwStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST retlwStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		
		
					String pass1="";
					int arg1=0;
				
		{
		match(RETLW);
		pass1+="retlw ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0xFF))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x3400;
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		retlwStatement_AST = (AST)currentAST.root;
		returnAST = retlwStatement_AST;
		return s;
	}
	
	public final String  returnStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST returnStatement_AST = null;
		
		
					String pass1="";
					int arg1=0;
				
		{
		match(RETURN);
		pass1+="return ";
		}
		
					if((arg1>0xFF))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x0008;
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		returnStatement_AST = (AST)currentAST.root;
		returnAST = returnStatement_AST;
		return s;
	}
	
	public final String  sleepStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST sleepStatement_AST = null;
		
		
					String pass1="";
				
		{
		match(SLEEP);
		pass1+="sleep ";
		}
		
					
					hexword = 0x0063;
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		sleepStatement_AST = (AST)currentAST.root;
		returnAST = sleepStatement_AST;
		return s;
	}
	
	public final String  sublwStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST sublwStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		
		
					String pass1="";
					int arg1=0;
				
		{
		match(SUBLW);
		pass1+="sublw ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0xFF))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x3C00;
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		sublwStatement_AST = (AST)currentAST.root;
		returnAST = sublwStatement_AST;
		return s;
	}
	
	public final String  xorlwStatement() throws RecognitionException, TokenStreamException {
		String s="";
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST xorlwStatement_AST = null;
		Token  id1 = null;
		AST id1_AST = null;
		Token  num1 = null;
		AST num1_AST = null;
		
		
					String pass1="";
					int arg1=0;
				
		{
		match(XORLW);
		pass1+="xorlw ";
		{
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			id1_AST = astFactory.create(id1);
			astFactory.addASTChild(currentAST, id1_AST);
			match(IDENT);
			arg1 = sTable.getSymbolValue(id1.getText());pass1+=id1.getText();
			break;
		}
		case NUMBER:
		{
			num1 = LT(1);
			num1_AST = astFactory.create(num1);
			astFactory.addASTChild(currentAST, num1_AST);
			match(NUMBER);
			arg1 = str2int(num1.getText());pass1+=num1.getText();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		}
		
					if((arg1>0xFF))
						System.out.println("ERROR!!!!!");
					
					hexword = 0x3A00;
					hexword += arg1; 
		
					HEXString += Integer.toString(hexword, 16) + " " ;
					s += Integer.toString(hexword, 16) + " " ;
					
					/*System.out.println("HEX " + arg1 + " " + HEXString);*/
					if(passNumber==1)
						s = pass1;
				
		xorlwStatement_AST = (AST)currentAST.root;
		returnAST = xorlwStatement_AST;
		return s;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"end\"",
		"\"equ\"",
		"\"org\"",
		"\"addwf\"",
		"\"andwf\"",
		"\"clrf\"",
		"\"clrw\"",
		"\"comf\"",
		"\"decf\"",
		"\"decfsz\"",
		"\"incf\"",
		"\"incfsz\"",
		"\"iorwf\"",
		"\"movf\"",
		"\"movwf\"",
		"\"nop\"",
		"\"rlf\"",
		"\"rrf\"",
		"\"subwf\"",
		"\"swapf\"",
		"\"xorwf\"",
		"\"bcf\"",
		"\"bsf\"",
		"\"btfsc\"",
		"\"btfss\"",
		"\"addlw\"",
		"\"andlw\"",
		"\"call\"",
		"\"clrwdt\"",
		"\"goto\"",
		"\"iorlw\"",
		"\"movlw\"",
		"\"retfie\"",
		"\"retlw\"",
		"\"return\"",
		"\"sleep\"",
		"\"sublw\"",
		"\"xorlw\"",
		"COMMENT",
		"NEWLINE",
		"WS",
		"LCURLY",
		"RCURLY",
		"LPAR",
		"RPAR",
		"COMMA",
		"LBRC",
		"RBRC",
		"SEMI",
		"COLON",
		"ASSIGN",
		"PLUS",
		"MINUS",
		"AND",
		"OR",
		"EQ",
		"NEQ",
		"LT",
		"GT",
		"LTE",
		"GTE",
		"DIGIT",
		"DECIMAL",
		"BINARY",
		"HEX",
		"IDENT",
		"NUMBER",
		"ADDRESS",
		"LITERAL",
		"LETTER",
		"PROGRAM",
		"SUBPROGRAMBODY",
		"BASICDECL",
		"CONSTDECL",
		"STATEMENT",
		"ORGSTATEMENT",
		"INSTRUCTIONSTATEMENT",
		"ASMSTATEMENT",
		"ADDWFSTATEMENT",
		"ANDWFSTATEMENT",
		"CLRFSTATEMENT",
		"CLRWSTATEMENT",
		"COMFSTATEMENT",
		"DECFSTATEMENT",
		"DECFSZSTATEMENT",
		"INCFSTATEMENT",
		"INCFSZSTATEMENT",
		"IORWFSTATEMENT",
		"MOVFSTATEMENT",
		"MOVWFSTATEMENT",
		"NOPSTATEMENT",
		"RLFSTATEMENT",
		"RRFSTATEMENT",
		"SUBWFSTATEMENT",
		"SWAPFSTATEMENT",
		"XORWFSTATEMENT",
		"BSFSTATEMENT",
		"BCFSTATEMENT",
		"BTFSCSTATEMENT",
		"BTFSSSTATEMENT",
		"ADDLWSTATEMENT",
		"ANDLWSTATEMENT",
		"CALLSTATEMENT",
		"CLRWDTSTATEMENT",
		"GOTOSTATEMENT",
		"IORLWSTATEMENT",
		"MOVLWSTATEMENT",
		"RETFIESTATEMENT",
		"RETLWSTATEMENT",
		"SLEEPSTATEMENT",
		"SUBLWSTATEMENT",
		"XORLWSTATEMENT",
		"RETURNSTATEMENT",
		"LABELSTATEMENT"
	};
	
	protected void buildTokenTypeASTClassMap() {
		tokenTypeToASTClassMap=null;
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 4398046511040L, 32L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	
	}
