package gui;


import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.nio.channels.FileChannel;

import javax.swing.JEditorPane;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;

import com.sun.org.apache.bcel.internal.classfile.LineNumber;

/**
 * This class is going to be used for implementing the main functions specified in Gui.
 * Currently, the menubar functions are being implemented. 
 * @author OZGUR
 *
 */
public class GuiController {

	public static File curDir = new File("./"); // the field to set the directory to be opened in save/open dialog windows
	public static File lastOpen = null; // the field which holds the information of the last opened file.
	public static File activeFile = null;
	public PFrame p =null;
	public EditorPane editor = new EditorPane(this, p);
	
	public GuiController() {
		
	}
	
	/** 
	 * This method creates an open file dialog. The specified file is opened 
	 * and editor tab is added into the editor pane.
	 */
	public int openMenuPressed(PFrame callerFrame, EditorPane editorPane, String filePath ) {
		
		//System.out.println("openMenuPressed()");
		p = callerFrame;
		URL fileURL = null;
		File file = null;
		int flag = 0;
		// if the file path is specified, skip this part
		if(filePath == null)
		{
			JFileChooser fileChooser = new JFileChooser();		// create a new filechooser object
			ExampleFileFilter filter = new ExampleFileFilter(); // create a new examplefilter object
			filter.addExtension("asm");		// adds the specified extension to the list of file filters
			filter.setDescription("asm files"); // the explanation for the extension
			
			fileChooser.setFileFilter(filter); // sets "filter" as the filter of the openFile dialog 
			fileChooser.setCurrentDirectory(curDir); // sets the directory to be shown as "curDir" 

			int response = fileChooser.showOpenDialog(callerFrame);
			if(response == JFileChooser.APPROVE_OPTION)
			{
				file = fileChooser.getSelectedFile();
				flag = 1;
			}
		}
		else 
		{
			file = new File(filePath);
		}
		
		if (flag == 1 || filePath != null) {


			
			File copiedFile;
			
			if(flag == 1)
			{
				copiedFile =  new File(((PFrame)callerFrame).activeProject.getProjectPath()+"/"+file.getName());
				
			    try {
			        // Create channel on the source
			        FileChannel srcChannel = new FileInputStream(file.getPath()).getChannel();
			    
			        // Create channel on the destination
			        FileChannel dstChannel = new FileOutputStream(copiedFile.getPath()).getChannel();
			    
			        // Copy file contents from source to destination
			        dstChannel.transferFrom(srcChannel, 0, srcChannel.size());
			    
			        // Close the channels
			        srcChannel.close();
			        dstChannel.close();
			    } catch (IOException e) {
			    }
			}
			else
			{
				copiedFile = file;
			}
			
			curDir = copiedFile;
			
			
			
			// System.out.println(file);
			try {
				fileURL = file.toURL();
			} catch (MalformedURLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			int fileExistFlag=0, fileIndex = -1;
			for (int i = 0; i < editorPane.list.size(); i++) {
				if( editorPane.list.get(i).getFileName().equals(file.getName()) )
				{
					fileExistFlag = 1;
					fileIndex = i;
				}
			}
			

			
			if(fileExistFlag == 0)
			{
				if (fileURL != null) {
					if(!((PFrame)callerFrame).activeProject.projectFile.fileList.contains(curDir.getPath()))
					{
						((PFrame)callerFrame).activeProject.projectFile.fileList.add(curDir.getPath());
						((PFrame)callerFrame).activeProject.projectFile.save();
					}
					
					
					String line=null;
					BufferedReader inputStream = null;
					
					try {
						inputStream = new BufferedReader(new FileReader(copiedFile));
					} catch (FileNotFoundException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					String full="";
					try {
						while((line = inputStream.readLine()) !=null)
						{
							//	LineNumber 
								full +=	line;
							//	full += " ";
								full += "\n";
						}
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					try {
						inputStream.close();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					
					int arraySize = editorPane.currentSize+1;
					int index = editorPane.activeFileIndex+1;

					
					EditorArray editorTab = new EditorArray(editorPane, copiedFile.getName(), callerFrame.getPMenuBar(), callerFrame);
					JEditorPane editorTabField = editorTab.getEditFieldEditorPane();
					JScrollPane editorTabScrollPane = editorTab.getEditScrollPane();
					
					editorTab.setFileName(file.getName());
					editorTab.setFilePath(file.getPath());
					editorTab.getEditFieldEditorPane().setText(full);
					editorTab.getEditFieldEditorPane().setSelectionStart(1);
					editorTab.getEditScrollPane().setViewportView(editorTabField);

					editorTab.changeFlag = 0;
					editorPane.list.add(editorTab);
					editorPane.addTab(file.getName(), editorTabScrollPane);
	
					
					editorPane.currentSize = arraySize;
					editorPane.setSelectedIndex(index);
					//System.out.println(file.getName());
					lastOpen = copiedFile;
				}
			}
			else
			{
				editorPane.setSelectedIndex(fileIndex);
			}
		}	
		return 0;	
	}
	/**
	 *This method saves a modified file. The method creates a save as dialog and 
	 *prompts the user if necessary.
	 */
	public int saveMenuPressed(JFrame callerFrame, EditorPane editorPane) {
	
		JFileChooser fileChooser = new JFileChooser();
		ExampleFileFilter filter = new ExampleFileFilter();
		filter.addExtension("asm");
		filter.setDescription("asm files");
		
		if(editorPane.currentSize != 0)
		{
			fileChooser.setFileFilter(filter);
			fileChooser.setCurrentDirectory(curDir);
			@SuppressWarnings("unused")
			URL fileURL = null;
			File file = null, file2= null;
			String path = null;
			int index = editorPane.activeFileIndex;
			System.out.println("index"+index);
			EditorArray editorTab = editorPane.list.get(index);
		
			int girsinMi = 0;
			int savePenceresiGostersinMi = 1;
		
			if(lastOpen != null)
			{
				System.out.println("lastOpen != NULL  " + editorTab.changeFlag);
				if(editorTab.changeFlag == 1)
				{
					//System.out.println("changeFlag = 1");
					if (editorTab.getFileName() != null) {
						girsinMi = 1;
						savePenceresiGostersinMi  = 0;
						file = new File(editorTab.getFilePath());	
						System.out.println("filename is not null");
					}
					else
					{
						System.out.println("filename is null");
						savePenceresiGostersinMi = 1;
						girsinMi = 1;
					}
				}
				else girsinMi = 0;
				System.out.println(lastOpen.getPath());
			}
			else girsinMi = 1;
		
		
			if(girsinMi == 1)
			{
				if(savePenceresiGostersinMi == 1)
				{
					fileChooser.setCurrentDirectory(curDir);
					int response = fileChooser.showSaveDialog(callerFrame);
					curDir = fileChooser.getCurrentDirectory();
				
					if (response == JFileChooser.APPROVE_OPTION) {
				
						file = fileChooser.getSelectedFile();
						try {
							fileURL = file.toURL();
						} catch (MalformedURLException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
			
						int endIndex = file.getPath().length();
						int beginIndex = endIndex - 3;
						//System.out.println(beginIndex+" "+ endIndex);
						System.out.println(fileChooser.getFileFilter().getDescription());
						if( fileChooser.getFileFilter().
								getDescription().equals("asm files (.asm)"))
						{
							if( file.getPath().substring(beginIndex, endIndex).equals("asm") )
							{
								path = file.getPath();
								file2 = new File(path);
							}
							else 
							{
								path = file.getPath()+ ".asm";
								file2 = new File(path);
							}
							@SuppressWarnings("unused")
							FileWriter fstream = null;
							try {
								fstream = new FileWriter(file);
							} catch (IOException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}}
						else if(fileChooser.getFileFilter().
								getDescription().equals("All Files"))
						{
							file2 = new File(file.getPath());
						}
				
						int active = editorPane.activeFileIndex;
						FileWriter fstream = null;
						int writeFlag=0;
					
						if(file2.exists())
						{
							if( overWriteDialog(callerFrame) == 0 )
							{
								writeFlag = 1;
							}
							else return 0;
						}
						else 
						{
							writeFlag = 1;
						}
				
						if(writeFlag == 1)
						{
							try {
								fstream = new FileWriter(file2);
							} catch (IOException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
							BufferedWriter out = new BufferedWriter(fstream);
				
							String full=editorTab.getEditFieldEditorPane().getText();
				
							try {
								out.write(full);
								out.close();
							} catch (IOException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
							editorPane.setTitleAt(index, file2.getName());
							editorTab.setFileName(file2.getName());
							lastOpen = file2;
							editorPane.list.get(active).changeFlag = 0;
							return 0;
						}	
					}
				}
				else 
				{
					int active = editorPane.activeFileIndex;
					FileWriter fstream = null;
					try {
						fstream = new FileWriter(file);
					} catch (IOException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
					BufferedWriter out = new BufferedWriter(fstream);
		
					String full=editorTab.getEditFieldEditorPane().getText();
		
					try {
						out.write(full);
						out.close();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					editorPane.setTitleAt(index, file.getName());
					lastOpen = file;
					editorPane.list.get(active).changeFlag = 0;
					return 0;
				
				}
			}
		}
		return 0;
	}
	
	/**
	 * This method creates a overwrite dialog and returns the user response
	 * @return response (0=NO 1=YES 2=CANCEL) 
	 */
	private int overWriteDialog(JFrame caller) {
		
		String message = "This file already exists. Do you want to overwrite it?";
		int yes = JOptionPane.showConfirmDialog(caller, message, "Overwrite?", JOptionPane.YES_NO_OPTION);
		if(yes == 0 ) return 0;
		else if(yes == 1)return 1;
		else return 2;
					
	}
	
	/**
	 *This method creates a new file dialog. After the file is created, it is 
	 *added into editor panel.
	 */
	public int newFileMenuItemPressed(PFrame callerFrame, EditorPane editorPane, 
			String filename, String filePath) {
		
		System.out.println("newMenuPressed");
		int arraySize = editorPane.currentSize+1;
		int index = editorPane.activeFileIndex+1;
		filePath = filePath.substring(2, filePath.length());

		File file = new File(filePath); 
		
		
		FileWriter fstream = null;
		try {
			fstream = new FileWriter(file);
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		BufferedWriter out = new BufferedWriter(fstream);
		
		try {
			out.write("");
			out.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		EditorArray editorTab = new EditorArray(editorPane, file.getName(), callerFrame.getPMenuBar(), callerFrame);
		JEditorPane editorTabField = editorTab.getEditFieldEditorPane();
		JScrollPane editorTabScrollPane = editorTab.getEditScrollPane();
		
		editorTab.getEditFieldEditorPane().setText("");
		editorTab.getEditFieldEditorPane().setSelectionStart(1);
		editorTab.getEditScrollPane().setViewportView(editorTabField);
		editorTab.setFileName(file.getName());
		editorTab.setFilePath(file.getPath());
		editorTab.changeFlag = 0;
		editorPane.list.add(editorTab);
		editorPane.addTab(file.getName(), editorTabScrollPane);
		editorPane.currentSize = arraySize;
		editorPane.setSelectedIndex(index);
		lastOpen = file;

		return 0;
	}
	
	
	/**
	 *	This method saves a file with a different file path. The method creates 
	 *	a save as dialog and prompts the user if necessary.
	 */
	public int saveAsMenuPressed(JFrame callerFrame, EditorPane editorPane) {
	
		JFileChooser fileChooser = new JFileChooser();
		ExampleFileFilter filter = new ExampleFileFilter();
		filter.addExtension("asm");
		filter.setDescription("asm files");
		
		if(editorPane.currentSize != 0)
		{
			fileChooser.setFileFilter(filter);
			fileChooser.setCurrentDirectory(curDir);
			@SuppressWarnings("unused")
			URL fileURL = null;
			File file = null, file2= null;
			String path = null;
			int index = editorPane.activeFileIndex;
			System.out.println("index"+index);
			EditorArray editorTab = editorPane.list.get(index);
		
			int girsinMi = 0;
			int savePenceresiGostersinMi = 1;
		
			if(lastOpen != null)
			{
				System.out.println("lastOpen != NULL  " + editorTab.changeFlag);
				if(editorTab.changeFlag == 1)
				{
					//System.out.println("changeFlag = 1");
					if (editorTab.getFileName() != null) {
						girsinMi = 1;
						savePenceresiGostersinMi  = 0;
						file = new File(editorTab.getFilePath());	
						System.out.println("filename is not null");
					}
					else
					{
						System.out.println("filename is null");
						savePenceresiGostersinMi = 1;
						girsinMi = 1;
					}
				}
				else girsinMi = 0;
				System.out.println(lastOpen.getPath());
			}
			else girsinMi = 1;
		
			girsinMi = 1;
			savePenceresiGostersinMi = 1;
			
			if(girsinMi == 1)
			{
				if(savePenceresiGostersinMi == 1)
				{
					fileChooser.setCurrentDirectory(curDir);
					int response = fileChooser.showSaveDialog(callerFrame);
					curDir = fileChooser.getCurrentDirectory();
				
					if (response == JFileChooser.APPROVE_OPTION) {
				
						file = fileChooser.getSelectedFile();
						try {
							fileURL = file.toURL();
						} catch (MalformedURLException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
			
						int endIndex = file.getPath().length();
						int beginIndex = endIndex - 3;
						//System.out.println(beginIndex+" "+ endIndex);
						System.out.println(fileChooser.getFileFilter().getDescription());
						if( fileChooser.getFileFilter().
								getDescription().equals("asm files (.asm)"))
						{
							if( file.getPath().substring(beginIndex, endIndex).equals("asm") )
							{
								path = file.getPath();
								file2 = new File(path);
							}
							else 
							{
								path = file.getPath()+ ".asm";
								file2 = new File(path);
							}
							@SuppressWarnings("unused")
							FileWriter fstream = null;
							try {
								fstream = new FileWriter(file);
							} catch (IOException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}}
						else if(fileChooser.getFileFilter().
								getDescription().equals("All Files"))
						{
							file2 = new File(file.getPath());
						}
				
						int active = editorPane.activeFileIndex;
						FileWriter fstream = null;
						int writeFlag=0;
					
						if(file2.exists())
						{
							if( overWriteDialog(callerFrame) == 0 )
							{
								writeFlag = 1;
							}
							else return 0;
						}
						else 
						{
							writeFlag = 1;
						}
				
						if(writeFlag == 1)
						{
							try {
								fstream = new FileWriter(file2);
							} catch (IOException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
							BufferedWriter out = new BufferedWriter(fstream);
				
							String full=editorTab.getEditFieldEditorPane().getText();
				
							try {
								out.write(full);
								out.close();
							} catch (IOException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
							editorPane.setTitleAt(index, file2.getName());
							editorTab.setFileName(file2.getName());
							lastOpen = file2;
							editorPane.list.get(active).changeFlag = 0;
							return 0;
						}	
					}
				}
				else 
				{
					int active = editorPane.activeFileIndex;
					FileWriter fstream = null;
					try {
						fstream = new FileWriter(file);
					} catch (IOException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
					BufferedWriter out = new BufferedWriter(fstream);
		
					String full=editorTab.getEditFieldEditorPane().getText();
		
					try {
						out.write(full);
						out.close();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					editorPane.setTitleAt(index, file.getName());
					lastOpen = file;
					editorPane.list.get(active).changeFlag = 0;
					return 0;
				
				}
			}
		}
		return 0;
	}
	
    /** 
     * This method copies source file to destination file.
     * If the dst file does not exist, it is created
     * 
     * @param src source file
     * @param dst destination file
     * @throws IOException
     */
    public void copy(File src, File dst) throws IOException {
        InputStream in = new FileInputStream(src);
        OutputStream out = new FileOutputStream(dst);
    
        // Transfer bytes from in to out
        byte[] buf = new byte[1024];
        int len;
        while ((len = in.read(buf)) > 0) {
        	System.out.println("ALSANA: "+buf);
            out.write(buf, 0, len);
        }
        in.close();
        out.close();
    }
}