/**
 * 
 */
package simulator;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Point;
import java.awt.Rectangle;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import peripherals.Potentiometer;

/**
 * This class is the visualisation of the potentiometer peripheral of
 * CENG336 board
 * @author maho
 *
 */
@SuppressWarnings("serial")
public class PotentiometerPanel extends JPanel {

	Potentiometer potentiometer = null;
	private JSlider potentiometerHandle = null;
	private JLabel jLabel = null;
	public JLabel potentiometerValueLabel = null;

	/**
	 * Main constructor for the potentiometer panel. Sets the potentiometer simulator
	 * and initializes the panel.
	 */
	public PotentiometerPanel(Potentiometer potentiometer) {
		// TODO Auto-generated constructor stub
		this.potentiometer =  potentiometer;
		initialize();
	}
		


	

	/**
	 * This method initializes the potentiometer panel.
	 * 
	 */
	private void initialize() {
        potentiometerValueLabel = new JLabel();
        potentiometerValueLabel.setBounds(new Rectangle(23, 189, 81, 24));
        potentiometerValueLabel.setFont(new Font("Tahoma", Font.PLAIN, 10));
        potentiometerValueLabel.setText("0.000 mV");
        jLabel = new JLabel();
        jLabel.setBounds(new Rectangle(9, 6, 93, 15));
        jLabel.setText("Potentiometer");
        this.setLayout(null);
        this.setSize(new Dimension(102, 221));
        this.setLocation(new Point(410, 14));
        this.setBorder(BorderFactory.createMatteBorder(5, 5, 5, 5, Color.black));
        this.add(getPotentiometerHandle(), null);
        this.add(jLabel, null);
        this.add(potentiometerValueLabel, null);
			
	}


	/**
	 * This method initializes and returns the potentiometer slider.	
	 * 	
	 * @return javax.swing.JSlider	
	 */
	private JSlider getPotentiometerHandle() {
		if (potentiometerHandle == null) {
			potentiometerHandle = new JSlider();
			potentiometerHandle.setMaximum(5000000);
			potentiometerHandle.setValue(0);
			potentiometerHandle.setBounds(new Rectangle(11, 24, 77, 161));
			potentiometerHandle.setOrientation(JSlider.VERTICAL);
			potentiometerHandle.setPaintLabels(true);
			potentiometerHandle.addChangeListener(new ChangeListener()
			{

				public void stateChanged(ChangeEvent e) {
					// TODO Auto-generated method stub
					double value = (double)(PotentiometerPanel.this.potentiometerHandle.getValue()/1000.0);
					PotentiometerPanel.this.potentiometerValueLabel.setText( value + " mV" );
					PotentiometerPanel.this.potentiometer.setAnalogData(value);
				}
				
			});
		}
		return potentiometerHandle;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
